package algorithms;

/*
 * EpdMineo.java
 *
 * Created on 5. Juli 2007, 15:20
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
//import umontreal.iro.lecuyer.util.Num;

import static java.lang.StrictMath.*;
import static umontreal.iro.lecuyer.util.Num.*;
import Jama.Matrix;

/**
 * 
 * @author boehm
 */
public class EPD {

	/** Creates a new instance of EpdMineo */
	public EPD(int dim) {
		this.dim = dim;
		mu = new double[dim];
		sigma = new double[dim];
		beta = new double[dim];
		likelihood = new double[dim];
		costPrecalculation1 = new double[dim];
		costPrecalculation2 = new double[dim];
		lb = new double[dim];
		ub = new double[dim];
		betaL = new double[dim];
		betaU = new double[dim];
//		
		dimensions = new int[dim];
		for(int i = 0; i < dim; i++) dimensions[i] = i;
	}
	int[] dimensions;
	int dim;
	boolean verbose = false;
	boolean vverb = false;
	boolean correctSigma = false;
	public static double minSigma = 0.001;

	private double t1, t2, t6;
	private double log2 = log(2);

//	public double cost(double x, double mean, double sigma, double beta) {
//		return -log(gg(x, mean, sigma, beta)) / log2;
//	}

	public double[] mu; // center
	public double[] sigma; // rotation
	public double[] beta; // beta
	public double[] likelihood; // beta
	public double[] costPrecalculation1;
	public double[] costPrecalculation2;
	
	int i1;
	double tmp_sigma, tmp_beta, tmp_mu, tb1, tb2, tb3;
	
	public double cost(Matrix mdata) {
		t2 = 0d;
//		for(i1 = 0; i1 < dim; i1++){
		for(int dimi : dimensions) {
			tmp_beta = beta[dimi];
			tmp_mu = mu[dimi];
			t1 = 1 / sigma[dimi];
			tb3 = 1d + tmp_beta;
			t6 = costPrecalculation1[dimi] * exp (costPrecalculation2[dimi] * pow(abs((mdata.get(0,dimi) - tmp_mu) * t1), 2 / tb3));
			t2 += -log(t6) / log2;
		}
		return t2;
	}
	
	public double cost(double[] xVector) {
		
		i1 = 0;
		t2 = 0d;
		for(double x : xVector){
			tmp_beta = beta[i1];
			tmp_mu = mu[i1];
			t1 = 1 / sigma[i1];
			
//			tb1 = Num.lnGamma(0.15E1 + 0.15E1 * tmp_beta);
//			tb2 = exp(Num.lnGamma(0.5 + 0.5 * tmp_beta));
			tb3 = 1d + tmp_beta;
			
			t6 = costPrecalculation1[i1] * exp (costPrecalculation2[i1] * pow(abs((x - tmp_mu) * t1), 2 / tb3));
			
//			t6 = ( (pow(exp(tb1), 0.5)) / (tb3) * (pow(tb2, -0.15E1)))
//					* (t1) * 
//					exp(-(pow(exp(tb1) / tb2, 1 / (tb3))) * pow(abs((x - tmp_mu) * t1), 2 / (tb3)));
			t2 += -log(t6) / log2;
			i1++;
		}
		return t2;
		
		
		
//		t2 = 0d;
//		for (int i = 0; i < dim; i++) {
//			t2 += -log(gg(xVector[i], mu[i], sigma[i], beta[i])) / log2;
//		}
//		return t2;
	}

	public double cost(Matrix x, int dimensionIndex) {
		
		t1 = 1 / sigma[dimensionIndex];
		tmp_beta = beta[dimensionIndex];
		tmp_mu = mu[dimensionIndex];
		t6 = costPrecalculation1[dimensionIndex] * exp (costPrecalculation2[dimensionIndex] * pow(abs((x.get(0,dimensionIndex) - tmp_mu) * t1), 2 / (1d + tmp_beta)));
		
		return (-log(t6)) / log2;
//		return (-log(gg(x, mu[dimensionIndex], sigma[dimensionIndex], beta[dimensionIndex]))) / log2;
	}
	
	public double cost(double x, int dimensionIndex) {
		
		t1 = 1 / sigma[dimensionIndex];
		tmp_beta = beta[dimensionIndex];
		tmp_mu = mu[dimensionIndex];
		t6 = costPrecalculation1[dimensionIndex] * exp (costPrecalculation2[dimensionIndex] * pow(abs((x - tmp_mu) * t1), 2 / (1d + tmp_beta)));
		
		return (-log(t6)) / log2;
//		return (-log(gg(x, mu[dimensionIndex], sigma[dimensionIndex], beta[dimensionIndex]))) / log2;
	}

	
//	double gg(double x, double mu, double sigma, double beta) {
//		t1 = 1 / sigma;
//		t6 = ( (pow(exp(Num.lnGamma(0.15E1 + 0.15E1 * beta)), 0.5)) / (1 + beta) * (pow(exp(Num.lnGamma(0.5 + 0.5 * beta)), -0.15E1)))
//				* (t1) * 
//				exp(-c(beta) * pow(abs((x - mu) * t1), 2 / (1 + beta)));
//		return t6;
//	}
	
//	double gg(double x, int dimIndex) {
//		t1 = 1 / sigma[dimIndex];
//		tmp_beta = beta[dimIndex];
//		tmp_mu = mu[dimIndex];
//		t6 = costPrecalculation1[dimIndex] * exp (costPrecalculation2[dimIndex] * pow(abs((x - tmp_mu) * t1), 2 / (1d + tmp_beta)));
//		return t6;
//	}
	
	
	

//	public double[] codingCostObjects; // coding costs of assigned objects

	public double codingCostMin;
	public double codingCost0;
	
	double mu_limit, mu_mean, mu_sum;

	double sum, logsum, h2, pp, sigma_p, logp, pThroughSigma;

	double betaDimI, oh_mu, oh_sigma, oh_help, oh_h;

	double h;
	double[] r, r1, r2, r3, returner,  lb, ub, betaL, betaU;

	int n;

	double[] sample;

	boolean firstGuess = true;
	
	public void reset(){
		firstGuess = true;
		betaF = 0.00001;
	}
		
	public double[] estimate(double[] sample, int dimensionIndex) {
		this.sample = sample;
		n = sample.length;
		
		if(firstGuess){
			lb[dimensionIndex] = sample[0];
			ub[dimensionIndex] = sample[0];
			for (int i = 1; i < n; i++) {
				h = sample[i];
				lb[dimensionIndex] = min(lb[dimensionIndex], h);
				ub[dimensionIndex] = max(ub[dimensionIndex], h);
			}
			r1 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], -0.97, 0.0, betaF);
			r2 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], 0.0, 1.0, betaF);
			r3 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], 1.0, 5.0, betaF);
		}else{

			//			r1 = optimizeHelp(lb, ub, -0.97, 0.0, betaF);
//			r2 = optimizeHelp(lb, ub, 0.0, 1.0, betaF);
			
			if(betaL[dimensionIndex] < 0){
				r1 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex], betaU[dimensionIndex], betaF);
				r2 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex] , betaU[dimensionIndex] + .75, betaF);
				r3[3] = Double.NEGATIVE_INFINITY;
//				r2[3] = Double.NEGATIVE_INFINITY;
			}else if(betaL[dimensionIndex] < 1){
				r1 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex] , betaU[dimensionIndex], betaF);
				r2 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex] - .75, betaU[dimensionIndex], betaF);
				r3 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex], betaU[dimensionIndex] + .75, betaF);
//				r2[3] = Double.NEGATIVE_INFINITY;
//				r2 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex] - .25, betaU[dimensionIndex] + .75, betaF);
			}else{
				r1 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex], betaU[dimensionIndex], betaF);
				r2 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex] - .75, betaU[dimensionIndex], betaF);
				r3[3] = Double.NEGATIVE_INFINITY;
			}
		}
		firstGuess = false;
		betaF = 0.01;
		
		if (r1[3] >= r2[3] && r1[3] >= r3[3]){
			returner = r1;
		}else if (r2[3] >= r1[3] && r2[3] >= r3[3]){
			returner = r2;
		}else{
			returner = r3;
		}
		

		// double[] stdGauss = { 0.0, 1.0, 0.0 };
		mu[dimensionIndex] = tmp_mu = Double.isNaN(returner[0]) ? 0d : returner[0];
		sigma[dimensionIndex] = Double.isNaN(returner[1]) ? 1d : returner[1];
		beta[dimensionIndex] = tmp_beta = Double.isNaN(returner[2]) ? 0d : returner[2];
		likelihood[dimensionIndex] = returner[3];

		betaL[dimensionIndex] = returner[4];
		betaU[dimensionIndex] = returner[5];
		 
		t1 = 1 / sigma[dimensionIndex];
//		tb1 = lnGamma(0.15E1 + 0.15E1 * tmp_beta);
//		tb2 = exp(lnGamma(0.5 + 0.5 * tmp_beta));
//		tb3 = 1d + tmp_beta;
//		tb1 = lnGamma(0.15E1 + 0.15E1 * tmp_beta);
//		tb2 = exp(lnGamma(0.5 + 0.5 * tmp_beta));
//		tb3 = 1d + tmp_beta;
//		tb1 = returner[6];
//		tb2 = exp(lnGamma(0.5 + 0.5 * tmp_beta));
//		tb3 = 1d + tmp_beta;
		
		costPrecalculation1[dimensionIndex] = ( (sqrt(exp(returner[6]))) / (returner[8]) * (pow(returner[7], -0.15E1))) * (t1);
//		costPrecalculation2[dimensionIndex] = -(pow(exp(tb1) / tb2, 1 / (tb3)));
		costPrecalculation2[dimensionIndex] = -returner[9];
		

		
		return returner;
	}

	double p, pMin1, OneThroughp;

	double betaF = 0.001;

	double lb2optimize, ub2optimize, dldp, c;
	
	
	public double[] optimizeHelp(double lb, double ub, double betaL, double betaU, double betaF) {

		betaDimI = 0.5 * (betaL + betaU);

		p = 2 / (1 + betaDimI);
		logp = log(p);
		pp = p * p;
		OneThroughp = 1d / p;
		pMin1 = p - 1d;  
		
		// <--  mu 
		mu_limit = 0.001 * (ub - lb);
		oh_mu = 0.5 * (ub + lb);
		
		lb2optimize = lb;
		ub2optimize = ub;
		while (ub2optimize - lb2optimize > mu_limit) {
			mu_sum = 0.0;
			for (double sampleI : sample) {
				if (sampleI > oh_mu)
					mu_sum += pow(sampleI - oh_mu, pMin1);
				else
					mu_sum -= pow(oh_mu - sampleI, pMin1);
			}
			if (mu_sum > 0)
				lb2optimize = oh_mu;
			else
				ub2optimize = oh_mu;
			oh_mu = 0.5 * (ub2optimize + lb2optimize);
		}
		//  mu -->
		
		
		// <-- sigma calc
		sum = 0.0;
		for (double sampleI : sample)
			sum += pow(abs(sampleI - oh_mu), p);
		oh_sigma = max(minSigma, pow(sum / n, OneThroughp));
		// sigma -->

		while (betaU - betaL > betaF) {
			
			// <-- dldp
			sum = 0.0;
			logsum = 0.0;
			for (double sampleI : sample) {
				h = abs(sampleI - oh_mu);
				h2 = pow(h, p);
				sum += h2;
				logsum += h2 * log(h);
			}
			sigma_p = pow(oh_sigma, p);
			pThroughSigma = p / sigma_p;
			dldp = (n * logp - n + n * digamma(OneThroughp) + n * p - pThroughSigma * logsum + sum / sigma_p + sum * log(oh_sigma) * pThroughSigma) / pp;
			// dldp -->
			
			if (dldp > 0) {
				betaU = betaDimI;
			} else {
				betaL = betaDimI;
			}
			betaDimI = 0.5 * (betaL + betaU);
			p = 2 / (1 + betaDimI);
			logp = log(p);
			pp = p * p;
			OneThroughp = 1d / p;
			pMin1 = p - 1d;  

			// <--  mu estimation
			lb2optimize = lb;
			ub2optimize = ub;
			while (ub2optimize - lb2optimize > mu_limit) {
				mu_sum = 0.0;
				for (double sampleI : sample) {
					if (sampleI > oh_mu)
						mu_sum += pow(sampleI - oh_mu, pMin1);
					else
						mu_sum -= pow(oh_mu - sampleI, pMin1);
				}
				if (mu_sum > 0)
					lb2optimize = oh_mu;
				else
					ub2optimize = oh_mu;
				oh_mu = 0.5 * (ub2optimize + lb2optimize);
			}
			//  mu -->
			
			// <-- sigma calc
			sum = 0.0;
			for (double sampleI : sample)
				sum += pow(abs(sampleI - oh_mu), p);
			oh_sigma = max(minSigma, pow(sum / n, OneThroughp));
			// sigma -->
		
			
		}
		
		// <-- loglikelihood
		t = 1 + OneThroughp;
		// System.out.println("t:" + t); //negativ: -1.82
		d = lnGamma(t);
		// TEST
		oh_help = -n * (log(2 * pow(p, OneThroughp) * oh_sigma) + d) - sum / p / sigma_p;
		// loglike -->
		
//		oh_help = loglikelihood(oh_mu, oh_sigma);

		
		tb1 = lnGamma(0.15E1 + 0.15E1 * betaDimI);
		tb2 = exp(lnGamma(0.5 + 0.5 * betaDimI));
		tb3 = 1d + betaDimI;
		
		
		c = (pow(exp(tb1) / tb2, 1 / tb3));
		oh_sigma *= pow(c * p, OneThroughp);

		double[] r = { oh_mu, oh_sigma, betaDimI, oh_help, betaL, betaU, tb1, tb2, tb3, c };

		return r;
	}



	

	
	
	
//	public double[] optimizeHelp(double lb, double ub, double betaL, double betaU, double betaF) {
//
//		betaDimI = 0.5 * (betaL + betaU);
//
//		p = 2 / (1 + betaDimI);
//		logp = log(p);
//		pp = p * p;
//		OneThroughp = 1d / p;
//		pMin1 = p - 1d;  
//		
//		oh_mu = mu(lb, ub);
//		oh_sigma = sigma(oh_mu);
//
//		while (betaU - betaL > betaF) {
//			if (dldp(oh_mu, oh_sigma) > 0) {
//				betaU = betaDimI;
//			} else {
//				betaL = betaDimI;
//			}
//			betaDimI = 0.5 * (betaL + betaU);
//			p = 2 / (1 + betaDimI);
//			logp = log(p);
//			pp = p * p;
//			OneThroughp = 1d / p;
//			pMin1 = p - 1d;  
//
//			oh_mu = mu(lb, ub);
//			oh_sigma = sigma(oh_mu);
//		}
//		oh_help = loglikelihood(oh_mu, oh_sigma);
//
//		oh_sigma *= pow(c(betaDimI) * p, OneThroughp);
//
//		double[] r = { oh_mu, oh_sigma, betaDimI, oh_help, betaL, betaU };
//
//		return r;
//	}
//
//	public double mu(double lb, double ub) {
//		mu_limit = 0.001 * (ub - lb);
//		mu_mean = 0.5 * (ub + lb);
//
//		while (ub - lb > mu_limit) {
//			mu_sum = 0.0;
//			for (double sampleI : sample) {
//				if (sampleI > mu_mean)
//					mu_sum += pow(sampleI - mu_mean, pMin1);
//				else
//					mu_sum -= pow(mu_mean - sampleI, pMin1);
//			}
//			if (mu_sum > 0)
//				lb = mu_mean;
//			else
//				ub = mu_mean;
//			mu_mean = 0.5 * (ub + lb);
//		}
//		return mu_mean;
//	}
//
//	public double sigma(double mu) {
//		sum = 0.0;
//		for (double sampleI : sample)
//			sum += pow(abs(sampleI - mu), p);
//		return max(minSigma, pow(sum / n, OneThroughp));
//	}
//
//	public double dldp(double mu, double sigma) {
//		sum = 0.0;
//		logsum = 0.0;
//
//		for (double sampleI : sample) {
//			h = abs(sampleI - mu);
//			h2 = pow(h, p);
//			sum += h2;
//			logsum += h2 * log(h);
//		}
//		sigma_p = pow(sigma, p);
////		t1 = logp + Num.digamma(1.0 + OneThroughp) - 1.0;
//		pThroughSigma = p / sigma_p;
//		// return sum / pp / sigma_p + (log (sigma) * sum - logsum) / p / sigma_p - sample.length * t1 / pp ;
//		return (n * logp - n + n * digamma(OneThroughp) + n * p - pThroughSigma * logsum + sum / sigma_p + sum * log(sigma) * pThroughSigma) / pp;
//	}
//
//
//	double c(double beta) {
//
//		return (pow(exp(lnGamma(0.15E1 + 0.15E1 * beta)) / exp(lnGamma(0.5 + 0.5 * beta)), 1 / (1 + beta)));
//	}

	double t, d;

	

//	public double loglikelihood(double mu, double sigma) {
//		sum = 0.0;
//		for (double sampleI : sample)
//			sum += Math.pow(Math.abs(sampleI - mu), p);
//		// TEST
//		// System.out.println("p " + p); //negativ: -0.35
//		t = 1 + OneThroughp;
//		// System.out.println("t:" + t); //negativ: -1.82
//		d = lnGamma(t);
//		// TEST
//		return -n * (Math.log(2 * Math.pow(p, OneThroughp) * sigma) + d) - sum / p / Math.pow(sigma, p);
//		// return Math.pow (2*Math.pow (p, 1/p) * sigma * Num.gamma (1+1/p), sample.length) * Math.exp (-sum/p/Math.pow(sigma, p)) ;
//	}

}
