/*
 * FinalAssignment.java
 *
 * Created on November 17, 2006, 8:07 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package clusterer;
import java.util.*;
import Jama.*;
import eval.Cluster;
import compr.DataObject;

/**
 *
 * @author Administrator
 */
public class FinalAssignment {
    DataObject[] data;
    Cluster[] clusters;
    int precision;
    int dim;
    static int gauss = 0;
    static int uniform = 1;
    static int laplace = 2;
    static int numDistributions = 3; //gauss, uniform, laplace
    static double ln10 = Math.log(10);
    static double ln2 = Math.log(2);
    
    
    /** Creates a new instance of FinalAssignment */
    public FinalAssignment(DataObject[] data, Cluster[] clusters, int precision) {
        this.data = data;
        this.clusters = clusters;
        this.precision = precision;
        dim = data[0].coord.length;
//        for(int i = 0; i < clusters.length; i++)
//            bestModel(getObjects(clusters[i].ID), clusters[i]);
    }
    
    /*
    //Kosten: Wie in eval.Clustering, mit median, robust
    private void bestModel(DataObject[] obj, Cluster c){
        double cost_untrans = 0.0;
        //Verteilung der einzelnen Koordinaten
        int[] untrans_dist = new int[dim];
        double[] median = median(obj);
        for(int i = 0; i < dim; i++){
            double[] aktCost = cost(obj, median, i);
            int min = minCost(aktCost);
            if(min == 0){
                untrans_dist[i] = gauss;
                cost_untrans += aktCost[0];
            }
            if(min == 1){
                untrans_dist[i] = uniform;
                cost_untrans += aktCost[1];
            }
            if(min == 2){
                untrans_dist[i] = laplace;
                cost_untrans += aktCost[2];
            }
        }
        cost_untrans += dim * 32 * 2;
        // Art Verteilung
        cost_untrans += dim * 2;
        double cost_trans = 0.0;
        int[] trans_dist = new int[dim];
        //robust
        DataObject[] transData = robustPca(obj, c);
        double[] transMedian = median(transData);
        for(int i = 0; i < dim; i++){
            double[] aktCost = cost(transData, transMedian, i);
            int min = minCost(aktCost);
            if(min == 0){
                trans_dist[i] = gauss;
                cost_trans += aktCost[0];
            }
            if(min == 1){
                trans_dist[i] = uniform;
                cost_trans += aktCost[1];
            }
            if(min == 2){
                trans_dist[i] = laplace;
                cost_trans += aktCost[2];
            }
        }
        //Parameter zhlen
        cost_trans += dim*32*2 + dim*dim * 32;
        // Art Verteilung
        cost_trans += dim * 2;
        //System.out.println("costTrans " + cost_trans + " costUntrans " + cost_untrans);
        //set cluster parameters: dist, mean as median, variance as median of variances.
        if(cost_trans < cost_untrans){
            c.dist = trans_dist;
            c.mean = transMedian;
            c.var = medianVariance(transData, transMedian);
            for(int i = 0; i < dim; i++){
                double b = bounds(transData, i);
                c.ub[i] = b[0];
                c.lb[i] = b[1];
            }
        } else{
            c.dir = null;
            c.dist = untrans_dist;
            c.mean = median;
            c.var = medianVariance(obj, median);
            for(int i = 0; i < dim; i++){
                double b = bounds(obj, i);
                c.ub[i] = b[0];
                c.lb[i] = b[1];
            }
        }
        double costID = obj.length * Math.log((double)data.length/(double)obj.length)/Math.log(2);
        double cost = Math.min(cost_trans, cost_untrans) + costID;
        c.cost = cost;
    }
    
    public DataObject[] robustPca(DataObject[] untransData, Cluster c){
        //System.out.println("PCA Cluster " + c.ID + " numObj " + c.numObj);
        double[][] coordObj = new double[untransData.length][dim];
        for(int i = 0; i < untransData.length; i++){
            for(int j = 0; j < dim; j++)
                coordObj[i][j] = untransData[i].coord[j];
        }
        DataObject[] transData_pca = new DataObject[untransData.length];
        Matrix data = new Matrix(coordObj);
        double[] mean = median(untransData);
        c.mean = mean;
        Matrix covar = new Matrix(covarByMedian(untransData, c.mean));
        EigenvalueDecomposition eig = new EigenvalueDecomposition(covar);
        Matrix vectors = eig.getV();
        Matrix values = eig.getD();
        //System.out.println("EW");
        //values.print(5, 3);
        //System.out.println("EV");
        //vectors.print(5, 3);
        c.dir = vectors.getArrayCopy();
        double[][] transCoord = new double[c.numObj][dim];
        for(int i = 0; i < c.numObj; i++){
            for(int j = 0; j < dim; j++){
                for(int k = 0; k < dim; k++){
                    transCoord[i][k] += (untransData[i].coord[j]-c.mean[j]) * c.dir[j][k];
                }
            }
        }
        for(int i = 0; i < c.numObj; i++){
            double[] co = new double[dim];
            for(int j = 0; j < dim; j++)
                co[j] = transCoord[i][j];
            transData_pca[i] = new DataObject(co, untransData[i].number, untransData[i].clusterID);
        }
        
        return transData_pca;
    }
    
    
    public double[][] covarByMedian(DataObject[] data, double[] mean) {
        int numObj= data.length ;
        int dim = data[0].coord.length ;
        double [] sortarray = new double[numObj] ;
        double[][] cov = new double[dim][dim];
        if (numObj <5){
            for (int i=0 ; i<dim ; i++)
                cov[i][i]=1.0 ;
            return cov ;
        }
        for(int l1 = 0; l1 < dim; l1++) {
            for(int l2 = 0; l2 < dim; l2++) {
                for(int j = 0; j < numObj; j++)
                    sortarray[j] = (data[j].coord[l1]-mean[l1])*(data[j].coord[l2]-mean[l2]) ;
                
                Arrays.sort(sortarray) ;
                if (numObj%2 == 0)
                    
                    cov[l1][l2]=(sortarray[numObj/2-1]+sortarray[numObj/2])/2 ;
                else
                    
                    cov[l1][l2]=(sortarray[numObj/2-1]+sortarray[numObj/2]+sortarray[numObj/2+1])/3
                            ;
            }
            
        }
        double maxdiff = 0.0 ;
        for (int i=0 ; i<dim ; i++){
            double sum = 0.0 ;
            for (int j=0 ; j<dim ; j++)
                sum += Math.abs(cov[i][j]) ;
            double diff = 1.1*sum - 2.1*cov[i][i] ;
            if (diff>maxdiff)
                maxdiff = diff ;
        }
        if (maxdiff > 0.0)
            for (int i=0 ; i<dim ; i++)
                cov[i][i] += maxdiff ;
        
        return cov ;
    }
     */
    
    private double[] medianVariance(DataObject[] o, double[] median){
        double[] result = new double[dim];
        for(int i = 0; i < dim; i++){
            double[] sortArray = new double[o.length];
            for(int j = 0; j < o.length; j++)
                sortArray[j] = (o[j].coord[i]-median[i]) * (o[j].coord[i]-median[i]);
            Arrays.sort(sortArray);
            if (o.length%2 == 0)
                result[i]=(sortArray[o.length/2-1]+sortArray[o.length/2])/2;
            else
                result[i]=(sortArray[o.length/2-1]+sortArray[o.length/2]+sortArray[o.length/2+1])/3;
        }
        return result;
    }
    
    public void assign(){
        for(int i = 0; i < clusters.length; i++){
            DataObject[] d = getObjects(clusters[i].ID);
            bestCost(d, clusters[i]);
            System.out.println("mist");
        }
    }
    
    public double [] median(DataObject[] members) {
        int numObj= members.length ;
        int dim = members[0].coord.length ;
        double[] result = new double[dim];
        double [] sortarray = new double[numObj] ;
        for (int i=0 ; i<dim ; i++) {
            double median = 0.0 ;
            for (int j=0 ; j<numObj ; j++)
                sortarray[j]=members[j].coord[i] ;
            Arrays.sort(sortarray) ;
            if (numObj==1)
                result[i]=sortarray[0] ;
            else if (numObj%2 == 0)
                result[i]=(sortarray[numObj/2-1]+sortarray[numObj/2])/2 ;
            else
                result[i]=(sortarray[numObj/2-1]+sortarray[numObj/2]+sortarray[numObj/2+1])/3 ;
        }
        return result ;
    }
    /*
    public void assignPoints(){
        for(int i = 0; i < data.length; i++){
            double[] costs = new double[clusters.length];
            for(int j = 0; j < costs.length; j++){
                costs[j] = clusterCost(clusters[j], data[i]);
            }
        }
    }
     */
    
    
    private double clusterCost(Cluster c, DataObject o){
        double cost = 0.0;
        if(c.dir != null){
            //determine reduced coordinates and reduced mean: WHAT ABOUT VARIANCE??
            double[] redCoord = new double[dim];
            Matrix m = new Matrix(c.dir);
            Matrix x = rowVector(o.coord);
            Matrix xm = x.times(m);
            for(int j = 0; j < dim; j++)
                redCoord[j] = xm.get(0,j);
            double[] redMean = new double[dim];
            Matrix r = rowVector(c.mean);
            Matrix rm = r.times(m);
            for(int j = 0; j < dim; j++)
                redMean[j] = rm.get(0,j);
            for(int i = 0; i < dim; i++){
                if(c.dist[i] == gauss)
                    cost += gaussCost(redCoord[i], redMean[i], Math.sqrt(c.var[i]), precision);
                if(c.dist[i] == laplace)
                    cost += laplaceCost(redCoord[i], redMean[i], Math.sqrt(c.var[i]), precision);
                if(c.dist[i] == uniform)
                    cost += uniformCost(redCoord[i], c.lb[i], c.ub[i], precision);
            }
            
            
            
            
        }
        return cost;
        
    }
    
    
    /**
     * Determines the best coding scheme for all dimensions.
     * @param d DataObject[] cluster points
     */
    private void bestCost(DataObject[] d, Cluster c){
        c.dist = new int[dim];
        int[] result = new int[dim];
        if(c.dir != null){
            DataObject[] red = new DataObject[d.length];
            Matrix m = new Matrix(c.dir);
            for(int l = 0; l < red.length; l++){
                double[] redCoord = new double[dim];
                Matrix x = rowVector(d[l].coord);
                Matrix akt = x.times(m);
                for(int j = 0; j < dim; j++){
                    redCoord[j] = akt.get(0,j);
                }
                DataObject redObj = new DataObject(redCoord, d[l].number);
                redObj.clusterID = d[l].clusterID;
                red[l] = redObj;
            }
            double[] redMeanCoord = new double[dim];
            Matrix mx = rowVector(c.mean);
            Matrix akt = mx.times(m);
            for(int j = 0; j < dim; j++){
                redMeanCoord[j] = akt.get(0,j);
            }
            for(int i = 0; i < dim; i++){
                double[] aktCost = cost(red, redMeanCoord, i);
                int min = minCost(aktCost);
                if(min == 0)
                    c.dist[i] = gauss;
                if(min == 1)
                    c.dist[i] = uniform;
                if(min == 2)
                    c.dist[i] = laplace;
            }
        } else{
            for(int i = 0; i < dim; i++){
                double[] aktCost = cost(d, c.mean, i);
                int min = minCost(aktCost);
                if(min == 0)
                    c.dist[i] = gauss;
                if(min == 1)
                    c.dist[i] = uniform;
                if(min == 2)
                    c.dist[i] = laplace;
            }
        }
    }
    
    
    private DataObject[] getObjects(int ID){
        Vector<DataObject> d = new Vector<DataObject>();
        for(int i = 0; i < data.length; i++)
            if(data[i].clusterID == ID)
                d.add(data[i]);
        DataObject[] obj = new DataObject[d.size()];
        for(int i = 0; i < d.size(); i++)
            obj[i] = (DataObject)d.elementAt(i);
        return obj;
    }
    
    public double[] cost(DataObject[] o, double[] mean, int numCoord){
        double[] cost = new double[numDistributions];
        int dim = o[0].coord.length;
        double stdv = stdv(o, mean, numCoord);
        for(int i = 0; i < o.length; i++){
            cost[0] += gaussCost(o[i].coord[numCoord], mean[numCoord], stdv, precision);
        }
        double[] bounds = bounds(o, numCoord);
        for(int i = 0; i < o.length; i++){
            cost[1] += uniformCost(o[i].coord[numCoord], bounds[1], bounds[0], precision);
        }
        for(int i = 0; i < o.length; i++){
            cost[2] += laplaceCost(o[i].coord[numCoord], mean[numCoord], stdv, precision);
        }
        return cost;
    }
    
    private double laplaceCost(double x, double mean, double std, int precision){
        double b = std/Math.sqrt(2);
        if (b<Math.pow(10, -precision)/10)
            return 0 ;
        double pdf = 1/(2*b)*Math.exp(-Math.abs(x-mean)/b);
        double prob = Math.max(Double.MIN_VALUE, Math.min(1.0, pdf * Math.pow(10, -precision)));
        //return 100000;
        return Math.log(1.0/prob)/Math.log(2);
    }
    
    private double gaussCost(double x, double mean, double std, int precision){
       /* double pdf = Math.exp(-(x-mean)*(x-mean)/2.0/(std * std))/Math.sqrt(2 * Math.PI * std * std);
        double prob = pdf * Math.pow(10, -precision) ;
        if (std<4*Math.pow(10, -precision))
            System.err.println("Attention, resolution too large") ;*/
        double var = Math.max(std*std, Double.MIN_VALUE) ;
        return Math.max(0.0,(0.5*Math.log(2*Math.PI*var)+precision*ln10+Math.pow(x-mean,2)/2/var)/ln2 );
        
        //return Math.log(1/prob)/Math.log(2);
    }
    
    //bounds[0]: upper bound, bounds[1]: lower bound
    private double[] bounds(DataObject[] o, int numCoord){
        int dim = o[0].coord.length;
        double[] bounds = new double[2];
        for(int i = 0; i < bounds.length; i++){
            bounds[0] = -Double.MAX_VALUE;
            bounds[1] = Double.MAX_VALUE;
        }
        for(int i = 0; i < o.length; i++){
            for(int j = 0; j < dim; j++){
                if(o[i].coord[numCoord] > bounds[0])
                    bounds[0] = o[i].coord[j];
                if(o[i].coord[numCoord] < bounds[1])
                    bounds[1] = o[i].coord[j];
            }
        }
        return bounds;
    }
    
    private double uniformCost(double x, double lb, double ub, int precision){
        double prob ;
        if (Math.abs(ub-lb) < Math.pow(10, -precision))
            prob = 1 ;
        else
            prob = Math.pow(10, -precision) / Math.abs(ub - lb) ;
        return Math.log(1/prob)/Math.log(2);
    }
    
    private double stdv(DataObject[] o, double[] mean, int numCoord){
        double stdv = 0.0;
        for(int i = 0; i < o.length; i++)
            stdv += (o[i].coord[numCoord] - mean[numCoord]) * (o[i].coord[numCoord] - mean[numCoord]);
        return Math.sqrt(stdv/o.length);
    }
    
    private int minCost(double[] cost){
        int minIndex = cost.length+1;
        double min = Double.MAX_VALUE;
        for(int i = 0; i < cost.length; i++)
            if(cost[i] < min){
            minIndex = i;
            min = cost[i];
            }
        return minIndex;
    }
    
    public Matrix rowVector(double [] v) {
        return new Matrix(v, 1) ;
    }
    
}
