/*
 * GeneralizedGaussian.java
 *
 * Created on August 29, 2006, 9:04 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package dataGenerator;

/**
 *
 * @author Administrator
 */
public class GeneralizedGaussian {
    double mu;
    double sigma;
    double beta;
    double cBeta;             //c und omega hngen nur von beta ab, nicht von x
    double omegaBeta;

    
    /** Creates a new instance of GeneralizedGaussian */
    public GeneralizedGaussian(double mu, double sigma, double beta){
        this.mu = mu;
        this.sigma = sigma;
        this.beta = beta;
        this.cBeta = cBeta();
        this.omegaBeta = omegaBeta();
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
    }
    
    private double gamma(double d){
        return Functions.fgamma(d);
    }
    
    private double cBeta(){
        double exponent = 1/(1.0 + beta);
        double zaehler = gamma(1.5*(1.0 + beta));
        double nenner = gamma(0.5*(1.0 + beta));
        return Math.pow(zaehler/nenner, exponent);
    }
    
    private double omegaBeta(){
        double zaehler = 1.5*(1.0 + beta);
        zaehler =  Math.pow(zaehler, 0.5);
        zaehler = gamma(zaehler);
        double nenner = 0.5*(1.0 + beta);
        nenner = Math.pow(nenner, 1.5);
        nenner = gamma(nenner) * (1.0 + beta);
        return zaehler/nenner;
    }
    
    public double px(double x){
      double argument = Math.abs((x - mu)/sigma);
      double exponent = 2.0/(1.0 + beta); 
      return omegaBeta/sigma * Math.exp(-cBeta * Math.pow(argument, exponent));
    }
}
