  package de.lmu.entropyoutlier.algorithm;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

import Jama.Matrix;
import de.lmu.entropyoutlier.algorithm.*;
import de.lmu.outlier.utils.DataObject;
import de.lmu.outlier.utils.ReadData;
  
  class SynCMDL{
  
	  public SynCMDL(){
		  
	  }
	  public static void main(String args[]){
		  
	    	long   start   =   System.currentTimeMillis();
	        ReadData rd = new ReadData();
	        String fn = "DS2.txt";
	        ArrayList srcdata = new ArrayList();
	        int dim =0;
	        int num = 0;
	        try {
	        	File mFile = new File(fn);
	        	FileReader fr = new FileReader(mFile);
	        	BufferedReader br = new BufferedReader(fr);
	        	String line;
	        	
	        	while((line=br.readLine())!=null){
	        		line = line.trim();        		
	        		String[] str = line.split("\\s+");
	        		//System.out.println(str[0]);
	        		dim = str.length;
	        		ArrayList temp = new ArrayList(dim);    		
	        		for(int i=0;i<dim;i++){
	        			temp.add(Double.parseDouble(str[i]));
	        		}
	        		srcdata.add(temp);
	        		num++;
	        	}
	        } catch (IOException ex) {
	            ex.printStackTrace();
	        }   
	        double[][] src = new double[num][dim];
	        for(int i=0;i<srcdata.size();i++){
	        	for(int j=0;j<dim;j++){
	        		src[i][j] = (Double)((ArrayList) srcdata.get(i)).get(j);
	        		System.out.print(" " + src[i][j]);
	        	}
	        	System.out.println(" ");
	        }
	        
	        
	        System.out.println("Data size:" + srcdata.size() + "Dimensionality:" + dim);
  	
		  	
		  	System.out.println("Clustering by synchronization...");
	        for(int s =0;s<1;s++){
	        	
		        double param = 10+1*s;
		        SynC sync = new SynC();
		        ArrayList res = sync.syncluster(fn, param);     
		        int len = res.size();
		        double[][] data = new double[len][dim];
		        for(int i=0;i<res.size();i++){
		        	for(int j=0;j<dim;j++){
		        		data[i][j] = (Double)((ArrayList) res.get(i)).get(j);
		        	}
		        }
		        
		        ArrayList clusterSet = new ArrayList();
		        ArrayList noiseSet = new ArrayList();
		        
		        int[] f = new int[len];
		        for(int i=0;i<len;i++)
		        	f[i] = 0;
		        
		        for(int i=0;i<data.length; i++){
		        	ArrayList al = new ArrayList();
		        	int n = 0;
		        	if(f[i]==0){		        	
			        	for(int j=0;j<data.length;j++){
			        		double temp = 0;
			        		for(int k=0;k<dim;k++){
			        			temp+= (data[i][k]-data[j][k])*(data[i][k]-data[j][k]);
			        			}
		        			if(Math.abs(Math.sqrt(temp))<1e-2){
		        				f[j] = 1;
		        				al.add(j);	  
		        				n++;
			        		}
			        	}
		        	
			        	if(n>1)
			        		clusterSet.add(al);
			        	else
			        		noiseSet.add(i);
		        	}
		        }
		        System.out.println("Cluster Number:" +clusterSet.size());
		        System.out.println("Compute the coding cost...");
		        double synCost = 0.0;
			  	for(int i=0;i<clusterSet.size();i++){
			  		
			  		ArrayList al = (ArrayList)clusterSet.get(i);
			  		double[][] cdata = new double[al.size()][dim];
			  		for(int j=0;j<al.size();j++){
			  			for(int d=0;d<dim;d++){
			  				cdata[j][d] = src[(Integer)al.get(j)][d];
			  				System.out.print(" " + cdata[j][d]);
			  			}
			  			System.out.println(" ");
			  		}
			  		//System.out.print("cluster size " + cdata.length);
			  		int nn = cdata.length;			 
			  		//System.out.print("ICA");
				  	ICA ica = new ICA(dim);
				  	EPD epd = new EPD(dim);	
			        epd.reset();
			        ica.reset();
			        ica.doICA(cdata,nn);
			        double[][] nnProjectedWhitened = ica.whithenedMatrix.times(ica.mw.transpose()).getArrayCopy();
		
			        // estimate the EPD of cluster based on ICA	        
				    for (int j = 0; j < dim; j++)
				    {
				      double[] s2 = new double[nn];		      
				      for (int k = 0; k < nn; k++)
				      {
				        s2[k] = nnProjectedWhitened[k][j];
				      }				
				      epd.estimate(s2, j);
				    }
				    
				    // Coding cost
				    double tmp_cost = 0.0;	    
				    for (int j = 0; j < nn; j++) {
				      for (int j2 = 0; j2 < dim; j2++)
				      {
				        tmp_cost += epd.cost(nnProjectedWhitened[j][j2], j2);	
				        //System.out.println("Coding cost for epd = "+epd.cost(cdata[j][j2], j2));
				      }			
				      //System.out.println("Coding cost for M = "+ica.wscCost);
				      tmp_cost += ica.wscCost;
				    }
				    //System.out.println("Coding cost for cluster = "+ica.wscCost);
				    synCost += tmp_cost;
			  	}
			  	if(noiseSet.size()>0){
			  		double[][] cdata = new double[noiseSet.size()][dim];
			  		for(int j=0;j<noiseSet.size();j++){
			  			for(int d=0;d<dim;d++)
			  			cdata[j][d] = src[(Integer)noiseSet.get(j)][d];
			  			System.out.print(" " + cdata[j][1]);
			  		}
			  		int nn = cdata.length;	
				  	ICA ica = new ICA(dim);
				  	EPD epd = new EPD(dim);	
			        epd.reset();
			        ica.reset();
				  	ica = new ICA(dim);
				  	epd = new EPD(dim);		
			        //epd.reset();
			        //ica.reset();	        
			        ica.doICA(cdata,nn);
			        double[][] nnProjectedWhitened = ica.whithenedMatrix.times(ica.mw.transpose()).getArrayCopy();
		
			        // estimate the EPD of cluster based on ICA	        
				    for (int j = 0; j < dim; j++)
				    {
				      double[] s2 = new double[nn];		      
				      for (int k = 0; k < nn; k++)
				      {
				        s2[k] = nnProjectedWhitened[k][j];
				      }
				
				      epd.estimate(s2, j);
				    }
				    
				    // Coding cost
				    double tmp_cost = 0.0;	    
				    for (int j = 0; j < nn; j++) {
				      for (int j2 = 0; j2 < dim; j2++)
				      {
				        tmp_cost += epd.cost(nnProjectedWhitened[j][j2], j2);	
				        //System.out.println("Coding cost for epd = "+tmp_cost);
				      }			
				      //System.out.println("Coding cost for M = "+ica.wscCost);
				      tmp_cost += ica.wscCost;
				    }
				    //System.out.println("Coding cost for cluster = "+ica.wscCost);
				    synCost += tmp_cost;
			  	}
			  	System.out.println("Coding cost = "+synCost);
	        }
		    long   end   =   System.currentTimeMillis();
	        System.out.println("Time eclipse:"+(end-start)+ "ms.");
	        System.out.println("========================");
	  }
		  	
}