package de.lmu.outlier.utils;

import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;

import javax.swing.*;



/**
 * Plot Error
 * 
 * @author Junming Shao
 * @param None
 * Created on 26. Mar. 2009, 
 */

public class OutlierPlot extends javax.swing.JFrame{
	double[] count;
	double[][] lsforder;
	int[] n;
	int[] id;
	int[] idx;
	double[][] data;
	int ID;
	Color [] cols = {Color.GREEN, Color.BLUE, Color.RED, Color.ORANGE, Color.LIGHT_GRAY, Color.CYAN, Color.YELLOW, Color.PINK, Color.DARK_GRAY, Color.MAGENTA, Color.getHSBColor(0.0f, 0.5f, 1.0f), Color.getHSBColor(0.1f, 0.5f, 1.0f), Color.getHSBColor(0.2f, 0.5f, 1.0f), Color.getHSBColor(0.3f, 0.5f, 1.0f), Color.getHSBColor(0.4f, 0.5f, 1.0f), Color.getHSBColor(0.5f, 0.5f, 1.0f), Color.getHSBColor(0.6f, 0.5f, 1.0f), Color.getHSBColor(0.7f, 0.5f, 1.0f), Color.getHSBColor(0.8f, 0.5f, 1.0f), Color.getHSBColor(0.9f, 0.5f, 1.0f), Color.getHSBColor(1.0f, 0.5f, 1.0f), Color.GREEN, Color.BLUE, Color.RED, Color.ORANGE, Color.LIGHT_GRAY, Color.CYAN, Color.YELLOW, Color.PINK, Color.DARK_GRAY, Color.MAGENTA, Color.getHSBColor(0.0f, 0.5f, 1.0f), Color.getHSBColor(0.1f, 0.5f, 1.0f), Color.getHSBColor(0.2f, 0.5f, 1.0f), Color.getHSBColor(0.3f, 0.5f, 1.0f), Color.getHSBColor(0.4f, 0.5f, 1.0f), Color.getHSBColor(0.5f, 0.5f, 1.0f), Color.getHSBColor(0.6f, 0.5f, 1.0f), Color.getHSBColor(0.7f, 0.5f, 1.0f), Color.getHSBColor(0.8f, 0.5f, 1.0f), Color.getHSBColor(0.9f, 0.5f, 1.0f), Color.getHSBColor(1.0f, 0.5f, 1.0f)} ;
	    
 
    public OutlierPlot(double[] count, int[] n, int[] id, double[][] data, int[] idx, int ID){
    	this.count = count;
    	this.n = n;
    	this.id = id;
    	this.data = new double[data.length][data[0].length];
    	for(int i=0;i<data.length;i++){
    		for(int j=0;j<data[0].length;j++){
    			this.data[i][j] = data[i][j];
    		}   		
    	}
    	this.idx = idx;
    	this.ID = ID;
        DrawPanel pl = new DrawPanel();
        pl.setBackground(Color.WHITE);
        getContentPane().add(pl, BorderLayout.CENTER);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
   //Test
    /*
    public  static void main(String[] args){
    	double[] error = new double[5];
    	int[] k = new int[5];
    	
    	for(int i=0;i<error.length;i++){
    		error[i] = 2*Math.pow(i+1, 2)+5;
    		k[i] = i;
    	}
    	
    	PlotError plot = new PlotError(error,k);
    	plot.setTitle("Error-KCluter Curve");
        plot.setSize(800, 600);
        plot.setLocation(200, 200);
        plot.setVisible(true);	 
    }*/

    public OutlierPlot() {
		// TODO Auto-generated constructor stub
	}

	public class DrawPanel extends JPanel{

        public void paintComponent(Graphics g) {
        	
            super.paintComponent(g);
            Graphics2D g2 = (Graphics2D) g;
            g2.setStroke(new BasicStroke(4.0f));
            
            Line2D.Float x = new Line2D.Float(50.0f, 520.0f, 750.0f, 520.0f);
            Line2D.Float y = new Line2D.Float(50.0f, 20.0f, 50.0f, 520.0f);
            
            g2.draw(x);
            g2.draw(y);     
            
            g.setFont(new Font("Serif",Font.BOLD,20));  
            // x-axis
            float intervalx = (700f-50f)/n.length;
            double maxM = -Double.MAX_VALUE;
            double minM = Double.MAX_VALUE;
            for(int i=0;i<n.length;i++){
            	Line2D.Float ax = new Line2D.Float(50.0f+intervalx*(i+1), 517.0f, 50.0f+intervalx*(i+1), 523.0f);
            	//g2.draw(ax);
            	//g.drawString(""+(i+1), (int)(50+intervalx*(i+1)), 540); 
            	if(count[i]>maxM){
            		maxM = count[i];
            	}
            	if(count[i]<minM){
            		minM = count[i];
            	}
            }   
            
            System.out.println("mAX="+ maxM + "  MIN= " + minM);
            g2.setStroke(new BasicStroke(1.0f));
            g.drawString("Objects", 350, 555); 
            
            
            // y-axis
            g2.setStroke(new BasicStroke(4.0f));
            float intervaly = (480f-20f)/20;     
            
            for(int i=0;i<20;i++){
            	Line2D.Float ay = new Line2D.Float(47.0f, 520.0f-intervaly*(i+1), 53.0f, 520.0f-intervaly*(i+1));
            	g2.draw(ay);

            }             
            float iny = (float) ((maxM-minM)/20);
            g2.rotate(Math.PI/2, 20, 200);
            g.drawString("Outlier Factor", 0, 200);
            g2.rotate(-Math.PI/2, 20, 200);
            
            
            Line2D.Float arrowx1 = new Line2D.Float(740f, 515.0f, 750f, 520.0f);
            Line2D.Float arrowx2 = new Line2D.Float(740f, 525.0f, 750f, 520.0f);
            g2.draw(arrowx1);
            g2.draw(arrowx2);
            Line2D.Float arrowy1 = new Line2D.Float(45f, 32.0f, 50.0f, 20.0f);
            Line2D.Float arrowy2 = new Line2D.Float(55f, 32.0f, 50.0f, 20.0f);
            g2.draw(arrowy1);
            g2.draw(arrowy2);            
            //The Outlier Factor plot
            int numn = 0;
            for(int k=0;k<=ID;k++){
	            for(int i=0;i<n.length;i++){
	            	float min_x = 10;
	            	float max_x = 500;
	            	float min_y = 20;
	            	float max_y = 500;
	            	
	                float xCoord = (float) ((data[i][0]-min_x)/(max_x-min_x) * 1500+700);
	                float yCoord = (float) ((data[i][1]-min_y)/(max_y-min_y) * 1500+200);       
	                if(idx[i]==k){
	            		g2.setColor(cols[k]);
	            		Line2D.Double akt = new Line2D.Double(xCoord, 520-yCoord, xCoord, 520-yCoord);
	            		g2.draw(akt);
	            	}else if(idx[i]==-1){
	            		g2.setColor(Color.BLACK);
	            		Line2D.Double akt = new Line2D.Double(xCoord, 520-yCoord, xCoord, 520-yCoord);
	            		g2.draw(akt);

		            		numn = numn + 1;

	            	}	
	            }   
            }
            System.out.println("Total noise: " + numn/(ID+1) );
            
            g2.setStroke(new BasicStroke(1.0f));
            int nx = 0; 

            for(int k=0;k<=ID;k++){
	            for(int i=0;i<n.length;i++){
	            	if(idx[i]==k){
	            		nx++;
		            	Line2D.Float ay = new Line2D.Float(50+intervalx*(nx), 
		            			520.0f, 
		            			50+intervalx*(nx), 
		            			(float) (510.0f-(count[i]/iny)*intervaly));
		            	g2.setColor(cols[k]);
		            	g2.draw(ay);
	            	}
	            	
	            }     
            }
            
        }
    }
}