/*
 * ClusterInit.java
 *
 * Created on 24 October 2005, 12:40
 */

package eval;
import compr.*;
import io.IO;
import java.util.*;

/**
 *
 * @author Administrator
 */
public class ClusterInit {
    DataObject[] data;
    
    /** Creates a new instance of ClusterInit */
    public ClusterInit(DataObject[] data) {
        this.data = data;
    }
    
    public ClusterInit(){
        
    }
    
    public DataObject[] getData(){
        return this.data;
    }
    
    //fr clustering verfahren mit evtl. leeren clustern, z. b. k-means
    public Cluster[] init(DataObject[] data, int numCluster){
        Cluster[] clusters = new Cluster[numCluster];
        int[] clusterIDs = new int[numCluster];
        for(int i = 0; i < clusterIDs.length; i++)
            clusterIDs[i] = 0;
        for(int i = 0; i < data.length; i++){
            if(data[i].clusterID == 0)
                System.err.println("DO " + data[i].number + " clusterID 0");
            clusterIDs[data[i].clusterID-1] = data[i].clusterID;
        }
        int emptyCount = 0;
        for(int i = 0; i < clusterIDs.length; i++)
            if(clusterIDs[i] == 0)
                emptyCount++;
        for(int i = 0; i < clusters.length; i++){
            clusters[i] = new Cluster(clusterIDs[i]);
            clusters[i].numObj = getObjects(clusters[i]).length;
            clusters[i].dim = data[0].coord.length;
        }
        //leere Cluster wegwerfen
        if(emptyCount > 0){
            Cluster[] nonEmpty = new Cluster[numCluster-emptyCount];
            int c = 0;
            for(int i = 0; i < clusters.length; i++){
                if(clusters[i].numObj != 0){
                    nonEmpty[c] = clusters[i];
                    c++;
                }
            }
            clusters = nonEmpty;
        }
        return clusters;
    }
    
    //keine leeren cluster aber zahl cluster unbekannt, z. b. dbscan.
    public Cluster[] init(DataObject[] data){
        int numCluster = getNumCluster();
        Cluster[] clusters = new Cluster[numCluster];
        int[] clusterIDs = new int[numCluster];
        for(int i = 0; i < clusterIDs.length; i++)
            clusterIDs[i] = 0;
        for(int i = 0; i < data.length; i++){
            if(data[i].clusterID != 0)
                clusterIDs[data[i].clusterID-1] = data[i].clusterID;
        }
        for(int i = 0; i < clusters.length; i++){
            clusters[i] = new Cluster(clusterIDs[i]);
            clusters[i].numObj = getObjects(clusters[i]).length;
            clusters[i].dim = data[0].coord.length;
        }
        int nullID = nullToMax();
        for(int i = 0; i < clusters.length; i++)
            if(clusters[i].ID == 0)
                clusters[i].ID = nullID;
        return clusters;
    }
    
    //clusterID 0 auf MaxID+1 setzen, gibt neue ClusterID zurck
    private int nullToMax(){
        int maxID = 0;
        for(int i = 0; i < data.length; i++)
            if(data[i].clusterID > maxID)
                maxID = data[i].clusterID;
        for(int i = 0; i < data.length; i++)
            if(data[i].clusterID == 0)
                data[i].clusterID = maxID + 1;
        return maxID+1;
    }
    
    private int getNumCluster(){
        boolean[] ids = new boolean[data.length];
        for(int i = 0; i < ids.length; i++)
            ids[i] = false;
        int counter = 0;
        for(int i = 0; i < data.length; i++){
            int aktID = data[i].clusterID;
            if(!ids[aktID]){
                counter++;
                ids[aktID] = true;
            }
        }
        return counter;
    }
    
    private double[] mean(int ID){
        double[] mean = new double[data[0].coord.length];
        int counter = 0;
        for(int i = 0; i < data.length; i++)
            if(data[i].clusterID == ID){
            for(int j = 0; j < mean.length; j++)
                mean[j]+= data[i].coord[j];
            counter++;
            }
        for(int i = 0; i < mean.length; i++)
            mean[i]/=(double)counter;
        return mean;
    }
    
    public void setMeans(Cluster[] cl){
        for(int i = 0; i < cl.length; i++)
            cl[i].mean =  mean(cl[i].ID);
    }
    
    //clusterID gleich classID
    public Cluster[] clusterClassID(int numClass){
        Cluster[] c = new Cluster[numClass];
        for(int j = 0; j < numClass; j++){
            int counter = 0;
            for(int i = 0; i < data.length; i++)
                if (data[i].classID == j+1)
                    counter++;
            Cluster n = new Cluster(j+1);
            n.numObj = counter;
            n.dim = data[0].coord.length;
            c[j] = n;
        }
        for(int i = 0; i < data.length; i++)
            data[i].clusterID = data[i].classID;
        return c;
    }
    
    //zum Testen.
    public void setClusterID(){
        Random r = new Random();
        for(int i = 0; i < data.length; i++)
            data[i].clusterID = 1;
    }
    
    //ClusterIDs wie sie sind zur Evaluierung
    public Cluster[] evalClustering(){
        Cluster[] c = new Cluster[getNumCluster()];
        int counter = 0;
        boolean[] usedID = new boolean[data.length];
        for(int i = 0;  i < data.length; i++)
            if(!usedID[data[i].clusterID]){
            usedID[data[i].clusterID] = true;
            Cluster cn = new Cluster(data[i].clusterID);
            cn.numObj = getObjects(cn).length;
            c[counter] = cn;
            counter++;
            }
        renameClusterIDs(c);
        IO ea = new IO();
        //ea.printResult(data);
        return c;
    }
    
    //clusterIDs von 1 an
    public void renameClusterIDs(Cluster[] oldID){
        int newID = 0;
        int[] newIDs = new int[oldID.length];
        for(int i = 0; i < newIDs.length; i++)
            newIDs[i] = i+1;
        boolean[] rename = new boolean[oldID.length];
        for(int i = 0; i < rename.length; i++)
            rename[i] = true;
        for(int i = 0; i < oldID.length; i++){
            Cluster akt = oldID[i];
            for(int j = 0; j < newIDs.length; j++)
                if(akt.ID == newIDs[j])
                    rename[i] = false;   //Cluster soll nicht umbenannt werden
        }
        boolean[] usedIDs = new boolean[newIDs.length];
        for(int i = 0; i < oldID.length; i++)
            if(!rename[i])
                usedIDs[oldID[i].ID-1] = true;
        for(int i = 0; i < oldID.length; i++){
            if(rename[i]){
                for(int j = 0; j < newIDs.length; j++)
                    if(!usedIDs[j])
                        newID = newIDs[j];
                changeClusterID(oldID[i].ID, newID);
                usedIDs[newID-1] = true;
                oldID[i].ID = newID;
            }
            
        }
        
    }
    
    private void changeClusterID(int oldID, int newID){
        for(int i = 0; i < data.length; i++)
            if(data[i].clusterID == oldID)
                data[i].clusterID = newID;
    }
    
    private DataObject[] getObjects(Cluster c){
        Vector memb = new Vector();
        int counter = 0;
        for(int j = 0; j < data.length; j++)
            if(data[j].clusterID == c.ID){
            memb.addElement(data[j]);
            counter++;
            }
        DataObject[] d = new DataObject[counter];
        for(int i = 0; i < counter; i++)
            d[i] = (DataObject)memb.elementAt(i);
        return d;
    }
    
}
