/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package filterCluster;

import io.IO;
import compr.DataObject;
import ica.IcaCost;
import clusterer.IcaCluster;

/**
 *Test the two filtering algorithms for SIGMOD.
 * @author plant
 */
public class RunFilterOCI {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        String dir = "noise50.txt";
        IO ea = new IO(dir, 2);
        DataObject[] data = ea.readClassFile();
        IcaCost ic = new IcaCost(data);
        //report runtime
        long startTime = System.currentTimeMillis();

        //loopwise filtering
        IcaCluster[] result = ic.robustGenGauss();
        //iterative repartitioning
        //IcaCluster[] result = ic.fastRobustGenGauss();

        long endTime = System.currentTimeMillis();
        double runtime = (double) (endTime - startTime) / 1000;

        //evaluate result: clusterID 0: core, 1: noise
        System.out.println("runtime: " + runtime);
        System.out.println("core: " + result[0].numObj + " noise: " + result[1].numObj);
        //class labels: 3: cluster, 4: noise
        int tp = 0;
        int fp = 0;
        int tn = 0;
        int fn = 0;
        for(int i = 0; i < data.length; i++){
            if(data[i].classID == 3 && data[i].clusterID == 0)
                tp++;
            if(data[i].classID == 3 && data[i].clusterID == 1)
                fn++;
            if(data[i].classID == 4 && data[i].clusterID == 1)
                tn++;
            if(data[i].classID == 4 && data[i].clusterID == 0)
                fp++;
        }
        double precision = (double)tp/(double)(tp + fp);
        double recall = (double)tp/(double)(tp + fn);
        System.out.println("precision: " + precision);
        System.out.println("recall: " + recall);
        }
        
    }

