
/*
 * IcaCost.java
 *
 * Created on 1. September 2006, 10:07
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package ica;
import io.IO;
import compr.DataObject;
import visu.VisuInfo;
import gengauss.GenGauss;
import gengauss.EpdMineo;
//import gengauss.GenGaussOld;
import clusterer.IcaCluster;
import Jama.*;
import java.text.NumberFormat;
import java.util.*;

/**
 * Test: Coding cost in white space with correction. Kosten im geweisselten Raum sind gleich den PCA-Kosten!!!! Ica bringt nix
 * @author boehm
 */
public class IcaCostBIC {
    int numObj;
    DataObject[] data;
    int dim;
    
    static int minschl = 3;
    static int maxschl = 20;
    
    /** Creates a new instance of IcaCost */
    public IcaCostBIC(DataObject[] data) {
        this.numObj = data.length;
        this.dim = data[0].coord.length;
        this.data = data;
    }
    
    public IcaCostBIC(){
    }
    
    
    public int[] getClusterID(){
        int[] ids = new int[numObj];
        for(int i = 0; i < numObj; i++)
            ids[i] = data[i].clusterID;
        return ids;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        int dim = 2;
        //IO ea = new IO("icaQuadratNoise5.txt", dim); //geht nicht mehr.
        //IO ea = new IO("icaQuadratNoise1.txt", dim); //ein Noisepkt. ist noch ok.
        IO ea = new IO("icaTest500Noise3schwer.txt", dim); //geht schon nicht mehr.
        //IO ea = new IO("icaQuadratNoise2.txt", dim); //geht schon nicht mehr.
        //IO ea = new IO("icaQuadrat.txt", dim);
        //IO ea = new IO("2cluster.txt", dim); //ica uniform am besten.
        //IO ea = new IO("icaTest1.txt", dim); //am besten ist laplacian ica?
        
        //IO ea = new IO("rotatedLpl.txt", dim); //gut: am besten ist laplacian ica
        //IO ea = new IO("icaTest500Noise3.txt", dim) ;
        //IO ea = new IO("icaTest200Noise10.txt", dim) ;
        //IO ea = new IO("icaTest100Noise10.txt", dim) ;
        
        DataObject[] d = ea.readFile();
        IcaCost i = new IcaCost(d);
        i.robustGenGauss();
        VisuInfo visu = new VisuInfo(d, "original space");
        visu.setSize(600,600);
        visu.setLocation(100,0);
        visu.setVisible(true);
        
        //i.IcaTest(d);
        //i.pca(d);
    }
    
    public double[][] pca(DataObject[] data){
        boolean verbose = false;
        int dim = data[0].coord.length;
        double[][] d = new double[numObj][dim];
        for(int i = 0; i < numObj; i++)
            for(int j = 0; j < dim; j++)
                d[i][j] = data[i].coord[j];
        Matrix dm = new Matrix(d);
        double[] mean = mean(d);
        Matrix covar = new Matrix(covar(d, mean));
        EigenvalueDecomposition eig = new EigenvalueDecomposition(covar);
        Matrix vectors = eig.getV();
        Matrix values = eig.getD();
        if(verbose){
            System.out.println("EW");
            values.print(5, 3);
            System.out.println("EV");
            vectors.print(5, 3);
        }
        double[][] dir = vectors.getArrayCopy();
        double[][] tdata= new double[numObj][dim];
        for(int i = 0; i < numObj; i++){
            for(int j = 0; j < dim; j++){
                for(int k = 0; k < dim; k++){
                    tdata[i][k] += (d[i][j]-mean[j]) * dir[j][k];
                }
            }
        }
        return tdata;
    }
    
    /**
     * indirectQuantile
     * partitions arr[] such that the smallest i elements are at the left side of the array
     * where "smaller" means that cost[arr[j1]] < cost[arr[j2]] if j1<i and j2>=i. In case of
     * tie situations, cost[...] <= cost[...] is allowed.
     * @param arr
     * @param cost
     * @param i
     */
    /******
     * public void indirectQuantile(int [] arr, double [] cost, int i) {
     * int num = arr.length ;
     * if (num != cost.length || i > num)
     * System.out.println("Error") ;
     * int a = 0 ;
     * int b = num ;
     * while (a < b) {
     * double pivot = cost[arr[b-1]] ;
     * int aa = a ;
     * int bb = b-2 ;
     * while (cost[arr[aa]] < pivot) aa++ ;
     * while (cost[arr[bb]] > pivot) bb-- ;
     * if (aa < bb) {
     * int h = arr [aa] ;
     * arr [aa] = arr [bb] ;
     * arr [bb] = h ;
     * } else {
     * int h = arr [b-1] ;
     * arr [b-1] = arr [bb] ;
     * arr [bb] = h ;
     * if (bb == i)
     * return ;
     * if (bb < i) a = bb + 1 ;
     * else b = bb ;
     * }
     * }
     * }
     ******/
    
    public void indirectQuantile(int [] arr, double [] cost, int k) {
        int l = 0 ;
        int r = arr.length - 1 ;
        while (r>l) {
            int i = partition(arr, cost, l, r) ;
            if (i >= k) r = i-1 ;
            if (i <= k) l = i+1 ;
        }
    }
    
    public int partition(int [] arr, double [] cost, int l, int r) {
        int i = l-1 ;
        int j = r ;
        double v = cost[arr [r]] ;
        for (;;) {
            while (cost[arr[++i]] < v) ;
            while (v < cost[arr[--j]]) if (j==l) break ;
            if (i >= j) break ;
            int h = arr[i] ;
            arr[i] = arr[j] ;
            arr[j] = h ;
        }
        int h = arr[i] ;
        arr[i] = arr[r] ;
        arr[r] = h ;
        return i ;
    }
    
    
    public IcaCluster mergedCluster(DataObject[] o){   
        IcaCluster result = new IcaCluster();
        if(o.length == 0){
            //empty cluster due to split
            System.err.println("empty");
            
        }
        int dim = o[0].coord.length;
        double[] realCenter = new double[dim]; //center of cluster pdf
        double[][] realRotation = new double[dim][dim]; //rotation+scaling
        double[] beta = new double[dim];
        GenGauss gg = new GenGauss() ;
        // gg = new GenGaussOld() ;
        Ica ica = new Ica();
        double[][] d = new double[o.length][] ;
        for (int j=0 ; j< o.length ; j++)
            d[j] = o[j].coord.clone();
        double[][] transform = new double[dim][dim];
        double[][] retransform = new double[dim][dim];
        double[] shift = new double[dim];
        double centered[][] = ica.centerData(d, shift);
        double whitened[][] = ica.whitenData(centered, transform, retransform);
        double bestcost = Double.MAX_VALUE ;
        Matrix localbestmw = new Matrix(1,1) ;
        double [][] localbestgenGaussParams = new double[0][] ;
        for (int schl=0 ; schl < 1 ; schl++) {
            double[][] w = ica.optimizeEntropy(whitened);
            Matrix mwhitened = new Matrix(whitened);
            Matrix mw = new Matrix(w);
            double[][] projectedWhitened =( mwhitened.times(mw.transpose())).transpose().getArrayCopy();
            double[][] genGaussParams = new double[dim][] ;
            double[] stdGauss = {0.0,1.0,0.0} ;
            // now determine the shape parameter for every dimension
            for (int j=0 ; j<dim ; j++) {
                try{
                    //genGaussParams [j] = gg.optimizeMSB(projectedWhitened [j]) ; //GenGauss
                    genGaussParams [j] = EpdMineo.optimizeMSP(projectedWhitened [j]) ; //GenGauss
                    for(int k = 0; k < genGaussParams[j].length; k++)
                        if(Double.isNaN(genGaussParams[j][k])){
                        System.out.println("------genGaussParams["+j+"]["+k+"] NaN-----------");
                        genGaussParams[j] = stdGauss;
                        }
                } catch(java.lang.StackOverflowError e){
                    System.out.println("-----stack overflow error-------");
                    genGaussParams[j] = stdGauss ;
                }
            }
            double cost = 0.0;
            // determine cost for every object in d
            for (int j=0 ; j < o.length ; j++) {
                for (int j2=0 ; j2<dim ; j2++) {
                    cost += gg.costVBIC(projectedWhitened [j2][j], genGaussParams [j2]) ;
                }
            }
            cost = cost*(-1.0);
            cost += ica.wscCost*o.length;
            if (bestcost > cost) {
                bestcost = cost ;
                localbestmw = mw ;
                localbestgenGaussParams = new double[dim][] ;
                for (int j=0 ; j<dim ; j++)
                    localbestgenGaussParams[j] = genGaussParams[j].clone() ;
                double[] mu = new double[dim];
                for(int j = 0; j < mu.length; j++)
                    mu[j] = localbestgenGaussParams[j][0];
                realCenter = (rowVector(shift).plus(rowVector(mu).times(localbestmw.times(new Matrix(retransform)).transpose()))).getRowPackedCopy();
                double[][] sigmaDiag = new double[dim][dim];
                for(int j = 0; j < dim; j++)
                    sigmaDiag[j][j] = 1.0/localbestgenGaussParams[j][1];
                realRotation = new Matrix(transform).times(localbestmw.transpose()).times(new Matrix(sigmaDiag)).getArrayCopy();
                for(int j = 0; j < dim; j++)
                    beta[j] = localbestgenGaussParams[j][2];
            }
        }
        result.numObj = o.length;
        result.dim = o[0].coord.length;
        result.realCenter = realCenter;
        result.realRotation = realRotation;
        result.beta = beta;
        result.cost = bestcost;
        return result;
    }
    
    
    /**
     * Determine Parameters and Cost for the merged cluster using EPD.
     * @return cost
     * @param o array of data objects
     */
    public double getMergedCost(DataObject[] o){
        int dim = o[0].coord.length;
        GenGauss gg = new GenGauss() ;
        // gg = new GenGaussOld() ;
        Ica ica = new Ica();
        double[][] d = new double[o.length][] ;
        for (int j=0 ; j< o.length ; j++)
            d[j] = o[j].coord.clone();
        double[][] transform = new double[dim][dim];
        double[][] retransform = new double[dim][dim];
        double[] shift = new double[dim];
        double centered[][] = ica.centerData(d, shift);
        double whitened[][] = ica.whitenData(centered, transform, retransform);
        double bestcost = Double.MAX_VALUE ;
        Matrix localbestmw = new Matrix(1,1) ;
        double [][] localbestgenGaussParams = new double[0][] ;
        for (int schl=0 ; schl < 1 ; schl++) {
            double[][] w = ica.optimizeEntropy(whitened);
            Matrix mwhitened = new Matrix(whitened);
            Matrix mw = new Matrix(w);
            double[][] projectedWhitened =( mwhitened.times(mw.transpose())).transpose().getArrayCopy();
            double[][] genGaussParams = new double[dim][] ;
            double[] stdGauss = {0.0,1.0,0.0} ;
            // now determine the shape parameter for every dimension
            for (int j=0 ; j<dim ; j++) {
                try{
                    //genGaussParams [j] = gg.optimizeMSB(projectedWhitened [j]) ; //GenGauss
                    genGaussParams [j] = EpdMineo.optimizeMSP(projectedWhitened [j]) ; 
                    for(int k = 0; k < genGaussParams[j].length; k++)
                        if(Double.isNaN(genGaussParams[j][k])){
                        System.out.println("------genGaussParams["+j+"]["+k+"] NaN-----------");
                        genGaussParams[j] = stdGauss;
                        }
                } catch(java.lang.StackOverflowError e){
                    System.out.println("-----stack overflow error-------");
                    genGaussParams[j] = stdGauss ;
                }
            }
            double cost = 0.0;
            // determine cost for every object in d
            for (int j=0 ; j < o.length ; j++) {
                for (int j2=0 ; j2<dim ; j2++) {
                    cost += gg.costVBIC(projectedWhitened [j2][j], genGaussParams [j2]) ;
                }
            }
            cost = cost*(-1.0);
            cost += ica.wscCost*o.length; //ica.wscCost negativ
            if (bestcost > cost) {
                bestcost = cost ;
                localbestmw = mw ;
                localbestgenGaussParams = new double[dim][] ;
                for (int j=0 ; j<dim ; j++)
                    localbestgenGaussParams[j] = genGaussParams[j].clone() ;
            }
        }
        
        return bestcost;
    }
    
    /**
     * RobustGenGauss
     * @param data
     */
    public IcaCluster[] robustGenGauss() {
        IcaCluster[] res = new IcaCluster[2]; //result: res[0]: cluster, res[1]: noise
        // initial decomposition
        NumberFormat n = NumberFormat.getInstance(Locale.ENGLISH) ;
        n.setMaximumFractionDigits(2);
        int dim = data[0].coord.length;
        int bestI = -1 ;
        double bestCost = Double.MAX_VALUE ;
        double[][] bestdd = new double[numObj][dim] ;
        GenGauss gg = new GenGauss() ;
        
        int [] bestIndexVector = new int [numObj] ;
        // Determine default cost per object for the noise
        // Here we assume that noise follows a uniform distribution which covers
        // all (i.e. cluster + noise) objects
        double noiseCost = 0.0 ;
        for (int i=0 ; i<dim ; i++) {
            double lb = Double.MAX_VALUE ;
            double ub = -Double.MAX_VALUE ;
            for (int j=0 ; j<numObj ; j++) {
                if (lb > data[j].coord[i])
                    lb = data[j].coord[i] ;
                if (ub < data[j].coord[i])
                    ub = data[j].coord[i] ;
            }
            noiseCost += Math.log(ub-lb) / Math.log(2.0) ;
        }
        
        
        double [] costVector = new double [numObj] ;
        for(int j = 0; j < numObj; j++)
            costVector[j] = -Double.MAX_VALUE;
        
        // main loop: consider i objects with highest cost as noise
        for (int i = 0 ; i< numObj-5 /*20*/ ; i++) {
            int [] indexVector = new int [numObj] ;
            for (int j=0 ; j<numObj ; j++)
                indexVector[j] = j ;
            // use numObj - i Objects with least cost for ica,
            // i.e. data[indexVector[j]] for all 0 <= j < numObj-i
            if (i>0)
                indirectQuantile(indexVector, costVector, numObj - i) ;
            double[][] d = new double[numObj - i][] ;
            for (int j=0 ; j<numObj-i ; j++)
                d[j] = data[indexVector[j]].coord.clone();
            
            
            Ica ica = new Ica();
            double[][] transform = new double[dim][dim];
            double[][] retransform = new double[dim][dim];
            double[] shift = new double[dim];
            double centered[][] = ica.centerData(d, shift);
            double whitened[][] = ica.whitenData(centered, transform, retransform);
            
            double localbestcost = Double.MAX_VALUE ;
            Matrix localbestmw = new Matrix(1,1) ;
            //TEST
            //Matrix localbestmw = new Matrix(2,2) ;
            //TEST
            double [][] localbestgenGaussParams = new double[0][] ;
            
            for (int schl=0 ; schl < 1 ; schl++) {
                
                double[][] w = ica.optimizeEntropy(whitened);
                Matrix mwhitened = new Matrix(whitened);
                Matrix mw = new Matrix(w);
                double[][] projectedWhitened =( mwhitened.times(mw.transpose())).transpose().getArrayCopy();
                //TEST
                //double[][] displayTest = (new Matrix(projectedWhitened)).transpose().getArrayCopy();
                //if (i<8){
                //    displayData((new Matrix(projectedWhitened)).transpose().getArrayCopy(), "Alt ICA "+i) ;
                //}
                double[][] genGaussParams = new double[dim][] ;
                double[] stdGauss = {0.0,1.0,0.0} ;
                // now determine the shape parameter for every dimension
                for (int j=0 ; j<dim ; j++) {
                    try{
                        genGaussParams [j] = gg.optimizeMSB(projectedWhitened [j]) ;
                    } catch(java.lang.StackOverflowError e){
                        System.out.println("-----stack overflow error-------");
                        genGaussParams[j] = stdGauss ;
                    }
                }
                // determine cost for every object in d
                
                double cost = noiseCost * i + ica.wscCost * (numObj - i) ;
                if (i == 244)
                    System.out.println("cost without coding cost: " + cost);
                
                for (int j=0 ; j<numObj-i ; j++) {
                    for (int j2=0 ; j2<dim ; j2++) {
                        cost += gg.costVBIC(projectedWhitened [j2][j], genGaussParams [j2]) ;
                    }
                }
                cost = cost*(-1.0);
                System.out.println("i" + i + "cost: " + cost );
                System.out.println("genGaussParams: ");
                for (int j = 0; j < dim; j++)
                    for(int k = 0; k < genGaussParams[j].length; k++)
                        System.out.print(genGaussParams[j][k] + " ");
                System.out.println();
                if (localbestcost >= cost) {
                    localbestcost = cost ;
                    localbestmw = mw ;
                    localbestgenGaussParams = new double[dim][] ;
                    for (int j=0 ; j<dim ; j++)
                        localbestgenGaussParams[j] = genGaussParams[j].clone() ;
                }
            }
            
//            double [][] tttt = (new Matrix(transform)).times(localbestmw.transpose()).getArrayCopy();
//
//            System.out.println(i+", "+n.format(tttt[0][0])+", "+n.format(tttt[0][1])+", "
//                    +n.format(tttt[1][0])+", "+n.format(tttt[1][1])+", "
//                    +n.format(localbestgenGaussParams [0][0])+", "+n.format(localbestgenGaussParams [0][1])+", "
//                    +n.format(localbestgenGaussParams [0][2])+", "+n.format(localbestgenGaussParams [1][0])+", "
//                    +n.format(localbestgenGaussParams [1][1])+", "+n.format(localbestgenGaussParams [1][2])+", "
//                    +noiseCost * i +", "+ ica.wscCost * (numObj - i)+", "+ localbestcost) ;
//
            
            // now do the same transformation again for the whole data matrix
            
            double [][] dd = new double[numObj][dim] ;
            for(int ii = 0; ii < numObj; ii++)
                for(int j = 0; j < dim; j++)
                    dd[ii][j] = data[ii].coord[j] - shift[j] ;
            //TEST
            
            //System.out.println("m");
            Matrix tdd = new Matrix(dd);
            Matrix ttransform = new Matrix(transform);
            Matrix tlocalbestmw = localbestmw.transpose();
            Matrix ttdd = new Matrix(dd).times(new Matrix(transform));
            //Matrix tttt = (new Matrix(dd).times(new Matrix(transform))).times(localbestmw.transpose());
            if(ttdd.getRowDimension() != 484 || ttdd.getColumnDimension() != 2 || ttransform.getRowDimension() != 2 || ttransform.getColumnDimension() != 2 || tlocalbestmw.getRowDimension() != 2 || tlocalbestmw.getColumnDimension() != 2)
                //TEST
                System.out.println("i " + i);
            double [][] wdd = ((new Matrix(dd).times(new Matrix(transform))).times(localbestmw.transpose())).getArrayCopy() ;
            
            for (int j=0 ; j<numObj ; j++)
                costVector [j] = gg.determineCost(wdd[j], localbestgenGaussParams) + ica.wscCost ;
            
            if (localbestcost < bestCost) {
                bestCost = localbestcost ;
                bestI = i ;
                bestIndexVector = indexVector.clone() ;
                bestdd = new double[wdd.length][] ;
                for (int j=0 ; j<wdd.length ; j++)
                    bestdd[j] = wdd[j].clone() ;
            }
            // if (i<8)
            //   displayData(wdd, numObj - i, indexVector, "Run i="+i);
            
        }
        for (int i=0 ; i<numObj ; i++) {
            if (i<numObj-bestI)
                data[bestIndexVector[i]].clusterID = 0 ;
            else
                data[bestIndexVector[i]].clusterID = 1 ;
        }
        
        System.out.println("OPTIMUM: "+bestI+", "+ bestCost) ;
        //displayData(bestdd, numObj - bestI, bestIndexVector, "optimum ICA") ;
        res[0] = new IcaCluster();
        res[0].ID = 0;
        res[0].numObj = numObj-bestI;
        res[0].cost = bestCost-bestI*noiseCost;
        res[1] = new IcaCluster();
        res[1].ID = 1;
        res[1].numObj = bestI;
        res[1].cost = bestI*noiseCost;
        return res;
    }
    
    public IcaCluster[] fastRobustGenGauss() {
        int dim = data[0].coord.length;
        IcaCluster[] res = new IcaCluster[2]; //result: res[0]: cluster, res[1]: noise
        double[] realCenter = new double[dim]; //center of cluster pdf
        double[][] realRotation = new double[dim][dim]; //rotation+scaling
        double[] beta = new double[dim];
        // initial decomposition
        NumberFormat n = NumberFormat.getInstance(Locale.ENGLISH) ;
        n.setMaximumFractionDigits(2);
        int bestI = -1 ;
        double bestCost = Double.MAX_VALUE ;
        double[][] bestdd = new double[numObj][dim] ;
        GenGauss gg = new GenGauss() ;
        // gg = new GenGaussOld() ;
        int [] bestIndexVector = new int [numObj] ;
        // Determine default cost per object for the noise
        // Here we assume that noise follows a uniform distribution which covers
        // all (i.e. cluster + noise) objects
        double noiseCost = 0.0 ;
        for (int i=0 ; i<dim ; i++) {
            double lb = Double.MAX_VALUE ;
            double ub = -Double.MAX_VALUE ;
            for (int j=0 ; j<numObj ; j++) {
                if (lb > data[j].coord[i])
                    lb = data[j].coord[i] ;
                if (ub < data[j].coord[i])
                    ub = data[j].coord[i] ;
            }
            noiseCost += Math.log(ub-lb) / Math.log(2.0) ;
        }
        double [] costVector = new double [numObj] ;
        for(int j = 0; j < numObj; j++)
            costVector[j] = -Double.MAX_VALUE;
        int i = 0;
        int lastI = 1;
        // main loop: consider i objects with highest cost as noise
        do{
            int [] indexVector = new int [numObj] ;
            for (int j=0 ; j<numObj ; j++)
                indexVector[j] = j ;
            // use numObj - i Objects with least cost for ica,
            // i.e. data[indexVector[j]] for all 0 <= j < numObj-i
            lastI = i;
            i = numObj - partitionCost(indexVector, costVector, noiseCost) ;
            double[][] d = new double[numObj - i][] ;
            //TEST
            if(numObj-i < 1){
                System.out.println("----empty cluster-----");
                break;
            }
            //TEST
            for (int j=0 ; j<numObj-i ; j++)
                d[j] = data[indexVector[j]].coord.clone();
            Ica ica = new Ica();
            double[][] transform = new double[dim][dim];
            double[][] retransform = new double[dim][dim];
            double[] shift = new double[dim];
            double centered[][] = ica.centerData(d, shift);
            double whitened[][] = ica.whitenData(centered, transform, retransform);
            double localbestcost = Double.MAX_VALUE ;
            Matrix localbestmw = new Matrix(1,1) ;
            double [][] localbestgenGaussParams = new double[0][] ;
            for (int schl=0 ; schl < maxschl && (schl < minschl || localbestcost >= bestCost); schl++) {
                double[][] w = ica.optimizeEntropy(whitened);
                Matrix mwhitened = new Matrix(whitened);
                Matrix mw = new Matrix(w);
                double[][] projectedWhitened =( mwhitened.times(mw.transpose())).transpose().getArrayCopy();
                double[][] genGaussParams = new double[dim][] ;
                double[] stdGauss = {0.0,1.0,0.0} ;
                // now determine the shape parameter for every dimension
                for (int j=0 ; j<dim ; j++) {
                    try{
                        //genGaussParams [j] = gg.optimizeMSB(projectedWhitened [j]) ;
                        genGaussParams [j] = EpdMineo.optimizeMSP(projectedWhitened [j]) ;
                        for(int k = 0; k < genGaussParams[j].length; k++)
                            if(Double.isNaN(genGaussParams[j][k])){
                            System.out.println("------genGaussParams["+j+"]["+k+"] NaN-----------");
                            genGaussParams[j] = stdGauss;
                            }
                    } catch(java.lang.StackOverflowError e){
                        System.out.println("-----stack overflow error-------");
                        genGaussParams[j] = stdGauss ;
                    }
                }
                // determine cost for every object in d
                double cost = noiseCost * i + ica.wscCost * (numObj - i) ;
                for (int j=0 ; j<numObj-i ; j++) {
                    for (int j2=0 ; j2<dim ; j2++) {
                        cost += gg.costV(projectedWhitened [j2][j], genGaussParams [j2]) ;
                    }
                }
                if (localbestcost > cost) {
                    localbestcost = cost ;
                    localbestmw = mw ;
                    localbestgenGaussParams = new double[dim][] ;
                    for (int j=0 ; j<dim ; j++)
                        localbestgenGaussParams[j] = genGaussParams[j].clone() ;
                }
            }
//            double [][] tttt = (new Matrix(transform)).times(localbestmw.transpose()).getArrayCopy();
//
//            System.out.println(i+", "+n.format(tttt[0][0])+", "+n.format(tttt[0][1])+", "
//                    +n.format(tttt[1][0])+", "+n.format(tttt[1][1])+", "
//                    +n.format(localbestgenGaussParams [0][0])+", "+n.format(localbestgenGaussParams [0][1])+", "
//                    +n.format(localbestgenGaussParams [0][2])+", "+n.format(localbestgenGaussParams [1][0])+", "
//                    +n.format(localbestgenGaussParams [1][1])+", "+n.format(localbestgenGaussParams [1][2])+", "
//                    +noiseCost * i +", "+ ica.wscCost * (numObj - i)+", "+ localbestcost) ;
//
            // now do the same transformation again for the whole data matrix
            double [][] dd = new double[numObj][dim] ;
            for(int ii = 0; ii < numObj; ii++)
                for(int j = 0; j < dim; j++)
                    dd[ii][j] = data[ii].coord[j] - shift[j] ;
            double [][] wdd = ((new Matrix(dd).times(new Matrix(transform))).times(localbestmw.transpose())).getArrayCopy() ;
            for (int j=0 ; j<numObj ; j++)
                costVector [j] = gg.determineCost(wdd[j], localbestgenGaussParams) + ica.wscCost ;
            if (localbestcost < bestCost) {
                double[] mu = new double[dim];
                for(int j = 0; j < mu.length; j++)
                    mu[j] = localbestgenGaussParams[j][0];
                realCenter = (rowVector(shift).plus(rowVector(mu).times(localbestmw.times(new Matrix(retransform)).transpose()))).getRowPackedCopy();
                double[][] sigmaDiag = new double[dim][dim];
                for(int j = 0; j < dim; j++)
                    sigmaDiag[j][j] = 1.0/localbestgenGaussParams[j][1];
                realRotation = new Matrix(transform).times(localbestmw.transpose()).times(new Matrix(sigmaDiag)).getArrayCopy();
                for(int j = 0; j < dim; j++)
                    beta[j] = localbestgenGaussParams[j][2];
                bestCost = localbestcost ;
                bestI = i ;
                bestIndexVector = indexVector.clone() ;
                bestdd = new double[wdd.length][] ;
                for (int j=0 ; j<wdd.length ; j++)
                    bestdd[j] = wdd[j].clone() ;
            }
            // if (i<8)
            //   displayData(wdd, numObj - i, indexVector, "Run i="+i);
            
        } while (i != lastI);
        for (int j=0 ; j<numObj ; j++) {
            if (j<numObj-bestI)
                data[bestIndexVector[j]].clusterID = 0 ;
            else
                data[bestIndexVector[j]].clusterID = 1 ;
        }
        System.out.println("OPTIMUM: "+bestI+", "+ bestCost) ;
        //displayData(bestdd, numObj - bestI, bestIndexVector, "optimum ICA") ;
        res[0] = new IcaCluster();
        res[0].ID = 0;
        res[0].numObj = numObj-bestI;
        res[0].cost = bestCost-bestI*noiseCost;
        res[0].realCenter = realCenter;
        res[0].realRotation = realRotation;
        res[0].beta = beta;
        res[1] = new IcaCluster();
        res[1].ID = 1;
        res[1].numObj = bestI;
        res[1].cost = bestI*noiseCost;
        return res;
    }
    
    public int partitionCost(int [] arr, double [] cost, double threshold) {
        int i = -1 ;
        int j = arr.length ;
        for (;;) {
            while (cost[arr[++i]] < threshold) if (i==arr.length-1) break;
            while (cost[arr[--j]] >= threshold) if (j==0) break ;
            if (i >= j) break ;
            int h = arr[i] ;
            arr[i] = arr[j] ;
            arr[j] = h ;
        }
        return i ;
    }
    
    
    /**
     * Chris algo
     * @param data
     */
    public void IcaTest(DataObject[] data){
        //display data in original space
        VisuInfo visu = new VisuInfo(data, "original space");
        visu.setSize(600,600);
        visu.setLocation(100,0);
        visu.setVisible(true);
        int dim = data[0].coord.length;
        double[][] d = new double[numObj][dim];
        for(int i = 0; i < numObj; i++)
            for(int j = 0; j < dim; j++)
                d[i][j] = data[i].coord[j];
        //ica and project in in whitened space
        Ica ica = new Ica();
        double[][] transform = new double[dim][dim];
        double[][] retransform = new double[dim][dim];
        double centered[][] = ica.centerData(d);
        //robust
        //double centered[][] = ica.centerByMedian(d);
        double whitened[][] = ica.whitenData(centered, transform, retransform);
//        //test -- coordinates of whitened data
//        System.out.println("whitened");
//        for(int i = 0; i < numObj; i++){
//            for(int j = 0; j < dim; j++)
//                System.out.print(whitened[i][j] + " ");
//            System.out.println();
//        }
        //show whitened data
        displayData(whitened, "whitened");
        double[][] w = ica.optimizeEntropy(whitened);
        Matrix mwhitened = new Matrix(whitened);
        Matrix mw = new Matrix(w);
        double[][] projectedWhitened = mwhitened.times(mw.transpose()).getArrayCopy();
        //show projected whitened data
        displayData(projectedWhitened, "projected whitened");
        //test distributions
        System.out.println("----------uniform cost------------");
        System.out.println("uniform untransformed " + uniformCost(d));
        //uniform cost ica
        double uc_ica = uniformCost(projectedWhitened);
        System.out.println("uniform Cost " + uc_ica);
        double[][] ev = ica.getEV();
        double[] kurt = kurtosis(projectedWhitened) ;
        System.out.println("Kurtosis: "+kurt[0]+" "+kurt[1]) ;
        double comp = whiteSpaceCompensation(ev);
        System.out.println("comp " + comp);
        double icaCost = uc_ica + comp;
        System.out.println("IcaCost " + icaCost);
        //uniform cost pca
        double[][] pcaData = pca(data);
        double uc_pca = uniformCost(pcaData);
        System.out.println("pcaCost " + uc_pca);
        //mean and variance in untransformed space
        double[] mean = mean(d);
        double[] sigma = new double[dim];
        for(int i = 0; i < dim; i++)
            sigma[i] = sigma(d, mean, i);
        //mean and variance in projected whitenend space: should be mean 0.0 and variance 1.0
        double[] mean_pwh = mean(projectedWhitened);
        double[] sigma_pwh = new double[dim];
        for(int i = 0; i < dim; i++)
            sigma_pwh[i] = sigma(projectedWhitened, mean_pwh, i);
        //mean and variance in pca-rotated space
        double[] mean_pca = mean(pcaData);
        double[] sigma_pca = new double[dim];
        for(int i = 0; i < dim; i++)
            sigma_pca[i] = sigma(pcaData, mean_pca, i);
        System.out.println("------------gaussian cost---------------");
        //gaussian untransformed
        double g= 0.0;
        //double[] mean = mean(d);
        for(int i = 0; i < dim; i++){
            //double sigma = sigma(d, mean, i);
            double aktCost = gaussianCost(d, sigma[i], mean, i);
            g += aktCost;
        }
        System.out.println("gaussian untransformed " + g);
        //gaussian ica
        double g_ica = 0.0;
        for(int i = 0; i < dim; i++)
            g_ica += gaussianCost(projectedWhitened, sigma_pwh[i], mean_pwh, i);
        g_ica += comp;
        System.out.println("gaussian ica " + g_ica);
        //gaussian pca
        double g_pca = 0.0;
        //double[] mean_pca = mean(pcaData);
        for(int i = 0; i < dim; i++){
            // double sigma_pca = sigma(pcaData, mean_pca, i);
            double aktCost = gaussianCost(pcaData, sigma_pca[i], mean_pca, i);
            g_pca += aktCost;
        }
        System.out.println("gaussian pca " + g_pca);
        System.out.println("-------------laplacian cost -------------");
        //laplacian untransformed
        double l= 0.0;
        for(int i = 0; i < dim; i++){
            double aktCost = laplacianCost(d, sigma[i], mean, i);
            l += aktCost;
        }
        System.out.println("laplacian untransformed " + l);
        //laplacian ica
        double l_ica = 0.0;
        for(int i = 0; i < dim; i++)
            l_ica += laplacianCost(projectedWhitened, sigma_pwh[i], mean_pwh, i);
        l_ica += comp;
        System.out.println("laplacian ica " + l_ica);
        //laplacian pca
        double l_pca = 0.0;
        for(int i = 0; i < dim; i++){
            double aktCost = laplacianCost(pcaData, sigma_pca[i], mean_pca, i);
            l_pca += aktCost;
        }
        System.out.println("laplacian pca " + l_pca);
        
        /*
        VisuSimple visu = new VisuSimple(data);
        visu.setSize(600,600);
        visu.setLocation(100,0);
        visu.setVisible(true);
         */
    }
    
    private void displayData(double[][] d, String title){
        DataObject[] data = new DataObject[d.length];
        for(int i = 0; i < d.length; i++){
            double[] coord = new double[dim];
            for(int j = 0; j < dim; j++)
                coord[j] = d[i][j];
            data[i] = new DataObject(coord, i);
        }
        VisuInfo visu = new VisuInfo(data, title);
        visu.setSize(600,600);
        visu.setLocation(100,0);
        visu.setVisible(true);
    }
    
    
    
    private void displayData(double[][] d, int cut, int [] indexVector, String title){
        DataObject[] data = new DataObject[numObj];
        for(int i = 0; i < numObj; i++){
            double[] coord = new double[dim];
            for(int j = 0; j < dim; j++)
                coord[j] = d[indexVector[i]][j];
            data[i] = new DataObject(coord, i);
            if (i<cut)
                data[i].clusterID=0 ;
            else
                data[i].clusterID=1 ;
        }
        VisuInfo visu = new VisuInfo(data, title);
        visu.setSize(600,600);
        visu.setLocation(100,0);
        visu.setVisible(true);
    }
    
    /**
     * univariate coorinate-wise gaussian distribution.
     * @param data
     * @param sigma
     * @param mean
     * @param coordIndex
     * @return
     */
    public double gaussianCost(double[][] data, double sigma, double[] mean, int coordIndex){
        double cost = 0.0;
        double factor = 1/(Math.sqrt(2 * Math.PI * sigma));
        for(int i = 0; i < numObj; i++)
            cost += -Math.log(Math.exp(-(data[i][coordIndex]- mean[coordIndex])*(data[i][coordIndex]-mean[coordIndex])/(2 * sigma)) * factor)/Math.log(2.0);
        return cost;
    }
    
    public double laplacianCost(double[][] data, double sigma, double[] mean, int coordIndex){
        double b = Math.sqrt(sigma/2.0);
        double factor = 1.0/(2*b);
        double cost = 0.0;
        for(int i = 0; i < numObj; i++)
            cost += -Math.log(Math.exp(-(Math.abs(data[i][coordIndex] - mean[coordIndex])/b))*factor)/Math.log(2.0);
        return cost;
    }
    
    public double [] kurtosis(double[][]data) {
        double [] result = new double[dim] ;
        for (int i=0 ; i<numObj ; i++)
            for (int j=0 ; j<dim ; j++)
                result [j] += Math.pow(data[i][j], 4.0) ;
        for (int j=0 ; j<dim ; j++)
            result [j] = result[j] / numObj - 3.0 ;
        return result ;
    }
    /**
     * uniform cost in whitenend space
     */
    public double uniformCost(double[][] data){
        //bestimme Schranken
        double[][] minMax = new double[2][dim];
        for(int i = 0; i < dim; i++){
            minMax[0][i] = Double.MAX_VALUE;
            minMax[1][i] = -Double.MAX_VALUE;
        }
        for(int i = 0; i < numObj; i++){
            for(int j = 0; j < dim; j++){
                if(data[i][j] < minMax[0][j])
                    minMax[0][j] = data[i][j];
                if(data[i][j] > minMax[1][j])
                    minMax[1][j] = data[i][j];
            }
        }
        /*
        for(int i = 0; i < dim; i++)
            System.out.println("dimension: " + i + " min " + minMax[0][i] + " max " + minMax[1][i]);
         */
        //bestimme Kosten
        double cost = 0.0;
        for(int i = 0; i < dim; i++)
            cost += Math.log(Math.abs(minMax[1][i] - minMax[0][i]))/Math.log(2);
        cost *= numObj;
        return cost;
    }
    
    public double whiteSpaceCompensation(double[][] ev){
        double comp = 0.0;
        for(int i = 0; i < dim; i++)
            comp += Math.log(ev[i][i])/Math.log(2);
        comp = comp * 0.5 * (double)numObj;
        return comp;
    }
    
    
    private double[] mean(double[][]o){
        double[] mean = new double[dim];
        for(int i = 0; i < numObj; i++)
            for(int j = 0; j < dim; j++){
            mean[j] += o[i][j];
            }
        for(int j = 0; j < dim; j++)
            mean[j] /= numObj;
        return mean;
    }
    
    private double[][] covar(double[][] o, double[] mean){
        double[][] cov = new double[dim][dim];
        for(int l = 0; l < numObj; l++)
            for(int i = 0; i < dim; i++)
                for(int j = 0; j < dim; j++)
                    cov[i][j]+= (o[l][j]-mean[j])*(o[l][i]-mean[i]);
        for(int i = 0; i < dim; i++)
            for(int j = 0; j < dim; j++)
                cov[i][j]/= numObj;
        return cov;
    }
    
    public Matrix rowVector(double [] v) {
        return new Matrix(v, 1) ;
    }
    
    
    private double sigma(double[][]o, double[] mean, int coordIndex){
        double sigma = 0.0;
        for(int i = 0; i < numObj; i++)
            sigma += (o[i][coordIndex]-mean[coordIndex]) * (o[i][coordIndex]-mean[coordIndex]);
        sigma /= (double)numObj;
        //return Math.sqrt(sigma);
        return sigma;
    }
    
    private double[][] zTransformation(double[][] data, double[] mean, double[] sigma){
        double[][] dz = new double[numObj][dim];
        for(int i = 0; i < numObj; i++)
            for(int j = 0; j < dim; j++)
                dz[i][j] = (data[i][j] - mean[j])/Math.sqrt(sigma[j]);
        return dz;
    }
    
}
