/*
 * LaplaceTest.java
 *
 * Created on 29. Juni 2006, 11:29
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package ica;
import visu.VisuSimple;
import visu.PCA;
import io.IO;
import compr.DataObject;
import eval.Clustering;
import Jama.*;

/**
 *
 * @author boehm
 */
public class LaplaceTest {
    
    /** Creates a new instance of LaplaceTest */
    public LaplaceTest() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        // IO ea = new IO("NEWDATA_5000.txt", 2);
        //ea.rotatedLaplacian(5000, 2, 50.0, 2.0);
        //ea.createLaplaceData(5000, 2, 50.0, 3.0);
        int dim = 2;
        IO ea = new IO("icaQuadrat.txt", dim);
        // IO ea = new IO("2cluster.txt", dim);
        DataObject[] d = ea.readFile();
        /*
        double[][] data = new double[d.length][dim];
        for(int i = 0; i < d.length; i++)
            for(int j = 0; j < dim; j++)
                data[i][j] = d[i].coord[j];
        Ica ica = new Ica();
        double[][] v = ica.optimizeEntropy(data) ;
         */
        LaplaceTest l = new LaplaceTest();
        DataObject[] icaData = l.icaNew(d);
        Clustering e = new Clustering(icaData, 3);
        double[] icaMean = e.mean(icaData);
        double sumIcaCost = 0.0;
        for(int i = 0; i < dim; i++)
            sumIcaCost += e.cost(icaData, icaMean, i)[2];
        System.out.println("icaCost " + sumIcaCost);
        
        DataObject[] pcaData = l.pca(d);
        Clustering c = new Clustering(pcaData, 3);
        double[] pcaMean = c.mean(pcaData);
        double sumPcaCost = 0.0;
        for(int i = 0; i < dim; i++)
            sumPcaCost += c.cost(pcaData, pcaMean, i)[2];
        System.out.println("pcaCost " + sumPcaCost);
        
        
        VisuSimple visu = new VisuSimple(d);
        visu.setSize(600,600);
        visu.setLocation(100,0);
        visu.setVisible(true);
        
    }
    
    public DataObject[] icaNew(DataObject[] untransData){
        int dim = untransData[0].coord.length;
        DataObject[] transData_ica = new DataObject[untransData.length];
        double[][] coordObj = new double[untransData.length][dim];
        for(int i = 0; i < untransData.length; i++){
            for(int j = 0; j < dim; j++)
                coordObj[i][j] = untransData[i].coord[j];
        }
        Ica ica = new Ica();
        double[][] w = ica.fastICA(coordObj);
        Matrix data = new Matrix(coordObj);
        Matrix wm = new Matrix(w);
        Matrix sm = wm.times(data.transpose());
        Matrix dataTrans = wm.transpose().times(sm);
        int numRows = dataTrans.getRowDimension();
        int numCols = dataTrans.getColumnDimension();
        for(int i = 0; i < numCols; i++){                 //transformed data as column-vectors
            double[] coord = new double[numRows];
            for(int j = 0; j < numRows; j++)
                coord[j] = dataTrans.get(j, i);
           transData_ica[i] = new DataObject(coord, untransData[i].number);
        }
        return transData_ica;
    }
    
    public DataObject[] ica(DataObject[] untransData){
        int dim = untransData[0].coord.length;
        double[][] coordObj = new double[untransData.length][dim];
        for(int i = 0; i < untransData.length; i++){
            for(int j = 0; j < dim; j++)
                coordObj[i][j] = untransData[i].coord[j];
        }
        Ica ica = new Ica();
        double[][] w = ica.optimizeEntropy(coordObj);
        Matrix data = new Matrix(coordObj);
        Matrix dir = new Matrix(w);
        double[] mean = mean(untransData);
        //Matrix icaTrans = (data.times(dir.inverse())).transpose() ;
        Matrix icaTrans = data.times(dir.inverse()); //gleiche kosten
        double[][] dirIca = icaTrans.getArrayCopy();
        DataObject[] transData_ica = new DataObject[untransData.length];
        double[][] transCoord = new double[untransData.length][dim];
        for(int i = 0; i < untransData.length; i++){
            for(int j = 0; j < dim; j++){
                for(int k = 0; k < dim; k++){
                    transCoord[i][k] += (untransData[i].coord[j]-mean[j]) * dirIca[j][k];
                }
            }
        }
        for(int i = 0; i < untransData.length; i++){
            double[] co = new double[dim];
            for(int j = 0; j < dim; j++)
                co[j] = transCoord[i][j];
            transData_ica[i] = new DataObject(co, untransData[i].number);
        }
        /*
        for(int i = 0; i < transData_ica.length; i++){
            double[] co = new double[dim];
            for(int j = 0; j < dim; j++)
                //co[j] = tr_ica[j][i];
                co[j] = tr_ica[i][j];
            transData_ica[i] = new DataObject(co, i);
        }
         */
        return transData_ica;
    }
    
    
    public DataObject[] pca(DataObject[] untransData){
        int dim = untransData[0].coord.length;
        double[][] coordObj = new double[untransData.length][dim];
        for(int i = 0; i < untransData.length; i++){
            for(int j = 0; j < dim; j++)
                coordObj[i][j] = untransData[i].coord[j];
        }
        DataObject[] transData_pca = new DataObject[untransData.length];
        Matrix data = new Matrix(coordObj);
        double[] mean = mean(untransData);
        Matrix covar = new Matrix(covar(untransData, mean));
        EigenvalueDecomposition eig = new EigenvalueDecomposition(covar);
        Matrix vectors = eig.getV();
        Matrix values = eig.getD();
        System.out.println("EW");
        values.print(5, 3);
        System.out.println("EV");
        vectors.print(5, 3);
        double[][] dir = vectors.getArrayCopy();
        double[][] transCoord = new double[untransData.length][dim];
        for(int i = 0; i < untransData.length; i++){
            for(int j = 0; j < dim; j++){
                for(int k = 0; k < dim; k++){
                    transCoord[i][k] += (untransData[i].coord[j]-mean[j]) * dir[j][k];
                }
            }
        }
        for(int i = 0; i < untransData.length; i++){
            double[] co = new double[dim];
            for(int j = 0; j < dim; j++)
                co[j] = transCoord[i][j];
            transData_pca[i] = new DataObject(co, untransData[i].number);
        }
        
        return transData_pca;
    }
    
    private double[] mean(DataObject[] o){
        double[] mean = new double[o[0].coord.length];
        for(int i = 0; i < o.length; i++)
            for(int j = 0; j < mean.length; j++){
            mean[j] += o[i].coord[j];
            }
        for(int j = 0; j < mean.length; j++)
            mean[j] /= o.length;
        return mean;
    }
    
    private double[][] covar(DataObject[] data, double[] mean){
        int dim = data[0].coord.length;
        double[][] cov = new double[dim][dim];
        for(int l = 0; l < data.length; l++)
            for(int i = 0; i < dim; i++)
                for(int j = 0; j < dim; j++)
                    cov[i][j]+= (data[l].coord[j]-mean[j])*(data[l].coord[i]-mean[i]);
        for(int i = 0; i < dim; i++)
            for(int j = 0; j < dim; j++)
                cov[i][j]/= data.length;
        return cov;
    }
    
    
}
