package oci;

import java.io.Serializable;

import Jama.Matrix;



/**
 * Cost of clusters without parameter cost.
 * @author Administrator
 */
public class IcaCluster implements Cloneable, Serializable{
    public int ID;
    public double cost; //coding cost + parameter cost as in OCI
    public double codingCost; //for outlier: all kinds of costs seperately
    public double parameterCost;
    public double idCost;
    public int[] assignedObjects; //number of assigned objects
    public double[] codingCostObjects; //coding costs of assigned objects
    public double[] beta;
    public double[] realCenter;
    public double[][] realRotation;
    public int dim;
    public int numObj;
    
    
    public double[] shift;
    public double transform[][];
    public Matrix mw;
	public Matrix mwhitened;
    
    public IcaCluster(int id){
        this.ID = id;
    }
    
    
   
    public IcaCluster() {
        ID = 0;
        cost = 0.0;
        this.beta = new double[1];
        this.realCenter = new double[1];
        this.realRotation = new double[1][1];
        this.dim = 1;
        this.numObj = 0;
    }
    
    
    
    
    public Object clone(){
        try{
            return super.clone();
        } catch (CloneNotSupportedException e){
            throw new InternalError();
        }
    }
    
    
    
    
}



