package visu;
/*
 * Grafik_Swing.java - Zeichnen in Swing-Komponenten
 *
 */

import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import javax.swing.*;

public class DistributionPlot extends javax.swing.JFrame {
    double[] data;
    
    public DistributionPlot(double[] data){
        this.data = data;
        setTitle("DistributionPlot");
        Leinwand l = new Leinwand();
        l.setBackground(Color.WHITE);
        getContentPane().add(l, BorderLayout.CENTER);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
    
    // innere Klasse fr Zeichenflche
    private class Leinwand extends JPanel {
        public void paintComponent(Graphics g) {
            super.paintComponent(g);
            Graphics2D g2 = (Graphics2D) g;
            g2.setStroke(new BasicStroke(4.0f));
            //Koordinatensystem
            Line2D.Float y = new Line2D.Float(10.0f, 0.0f, 10.0f, 500.0f);
            Line2D.Float x = new Line2D.Float(10.0f, 500.0f, 1000.0f, 500.0f);
            g2.draw(y);
            g2.draw(x);
            g2.setStroke(new BasicStroke(2.0f));
            //scale data into [0..1]
            double max = 0.0;
            for(int i = 0; i < data.length; i++){
                if(data[i] < Double.MAX_VALUE && data[i] > max){
                    max = data[i];
                }
            }
            double min = Double.MAX_VALUE;
            for(int i = 0; i < data.length; i++)
                if(data[i] < min)
                    min = data[i];
            if(min < 0)
                max += min;
            else
                max -= min;
            for(int i = 0; i < data.length; i++)
                if(min < 0)
                    data[i] += min;
                else
                    data[i] -= min;
            for(int i = 0; i < data.length; i++)
                data[i]/=max;
            //draw a bin for each
            g2.setColor(Color.BLUE);
            float step = (float)1000/(float)data.length;
            for(int i = 0; i < data.length; i++){
                g2.setStroke(new BasicStroke(2.0f));
                float xCoord = (float) (i *step+10);
                float yCoord = (float) data[i] * 500;
                yCoord = 500f - yCoord;
                if(data[i] == 1){
                    yCoord = 0;
                }
                Line2D.Float akt = new Line2D.Float(xCoord, yCoord, xCoord, 500.0f);
                g2.draw(akt);   
            }
        }
    }
}
