// Decompiled Using: FrontEnd Plus v2.03 and the JAD Engine
// Available From: http://www.reflections.ath.cx
// Decompiler options: packimports(3) 
// Source File Name:   EPD.java

package de.lmu.entropyoutlier.algorithm;

import Jama.Matrix;
import umontreal.iro.lecuyer.util.Num;
import de.lmu.outlier.utils.*;

public class EPD
{

    public EPD(int dim)
    {
        verbose = false;
        vverb = false;
        correctSigma = false;
        log2 = StrictMath.log(2D);
        firstGuess = true;
        betaF = 0.001D;
        this.dim = dim;
        mu = new double[dim];
        sigma = new double[dim];
        beta = new double[dim];
        likelihood = new double[dim];
        costPrecalculation1 = new double[dim];
        costPrecalculation2 = new double[dim];
        lb = new double[dim];
        ub = new double[dim];
        betaL = new double[dim];
        betaU = new double[dim];
        dimensions = new int[dim];
        for(int i = 0; i < dim; i++)
            dimensions[i] = i;

    }

    public double cost(Matrix mdata)
    {
        t2 = 0.0D;
        int arr$[] = dimensions;
        int len$ = arr$.length;
        for(int i$ = 0; i$ < len$; i$++)
        {
            int dimi = arr$[i$];
            tmp_beta = beta[dimi];
            tmp_mu = mu[dimi];
            t1 = 1.0D / sigma[dimi];
            tb3 = 1.0D + tmp_beta;
            t6 = costPrecalculation1[dimi] * StrictMath.exp(costPrecalculation2[dimi] * StrictMath.pow(StrictMath.abs((mdata.get(0, dimi) - tmp_mu) * t1), 2D / tb3));
            t2 += -StrictMath.log(t6) / log2;
        }

        return t2;
    }

    public double cost(double xVector[])
    {
        i1 = 0;
        t2 = 0.0D;
        double arr$[] = xVector;
        int len$ = arr$.length;
        for(int i$ = 0; i$ < len$; i$++)
        {
            double x = arr$[i$];
            tmp_beta = beta[i1];
            tmp_mu = mu[i1];
            t1 = 1.0D / sigma[i1];
            tb3 = 1.0D + tmp_beta;
            t6 = costPrecalculation1[i1] * StrictMath.exp(costPrecalculation2[i1] * StrictMath.pow(StrictMath.abs((x - tmp_mu) * t1), 2D / tb3));
            t2 += -StrictMath.log(t6) / log2;
            i1++;
        }

        return t2;
    }

    public double cost(Matrix x, int dimensionIndex)
    {
        t1 = 1.0D / sigma[dimensionIndex];
        tmp_beta = beta[dimensionIndex];
        tmp_mu = mu[dimensionIndex];
        t6 = costPrecalculation1[dimensionIndex] * StrictMath.exp(costPrecalculation2[dimensionIndex] * StrictMath.pow(StrictMath.abs((x.get(0, dimensionIndex) - tmp_mu) * t1), 2D / (1.0D + tmp_beta)));
        return -StrictMath.log(t6) / log2;
    }

    public double cost(double x, int dimensionIndex)
    {
        t1 = 1.0D / sigma[dimensionIndex];
        tmp_beta = beta[dimensionIndex];
        tmp_mu = mu[dimensionIndex];
        t6 = costPrecalculation1[dimensionIndex] * StrictMath.exp(costPrecalculation2[dimensionIndex] * StrictMath.pow(StrictMath.abs((x - tmp_mu) * t1), 2D / (1.0D + tmp_beta)));
        //System.out.println(t6);
        return -StrictMath.log(t6) / log2;
    }

    public void reset()
    {
        firstGuess = true;
        betaF = 1.0000000000000001E-005D;
    }

    public double[] estimate(double sample[], int dimensionIndex)
    {
        this.sample = sample;
        n = sample.length;
        if(firstGuess)
        {
            lb[dimensionIndex] = sample[0];
            ub[dimensionIndex] = sample[0];
            for(int i = 1; i < n; i++)
            {
                h = sample[i];
                lb[dimensionIndex] = StrictMath.min(lb[dimensionIndex], h);
                ub[dimensionIndex] = StrictMath.max(ub[dimensionIndex], h);
            }

            r1 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], -0.96999999999999997D, 0.0D, betaF);
            r2 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], 0.0D, 1.0D, betaF);
            r3 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], 1.0D, 5D, betaF);
        } else
        if(betaL[dimensionIndex] < 0.0D)
        {
            r1 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex], betaU[dimensionIndex], betaF);
            r2 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex], betaU[dimensionIndex] + 0.75D, betaF);
            r3[3] = (-1.0D / 0.0D);
        } else
        if(betaL[dimensionIndex] < 1.0D)
        {
            r1 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex], betaU[dimensionIndex], betaF);
            r2 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex] - 0.75D, betaU[dimensionIndex], betaF);
            r3 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex], betaU[dimensionIndex] + 0.75D, betaF);
        } else
        {
            r1 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex], betaU[dimensionIndex], betaF);
            r2 = optimizeHelp(lb[dimensionIndex], ub[dimensionIndex], betaL[dimensionIndex] - 0.75D, betaU[dimensionIndex], betaF);
            r3[3] = (-1.0D / 0.0D);
        }
        firstGuess = false;
        betaF = 0.01D;
        if(r1[3] >= r2[3] && r1[3] >= r3[3])
            returner = r1;
        else
        if(r2[3] >= r1[3] && r2[3] >= r3[3])
            returner = r2;
        else
            returner = r3;
        mu[dimensionIndex] = tmp_mu = Double.isNaN(returner[0]) ? 0.0D : returner[0];
        sigma[dimensionIndex] = Double.isNaN(returner[1]) ? 1.0D : returner[1];
        beta[dimensionIndex] = tmp_beta = Double.isNaN(returner[2]) ? 0.0D : returner[2];
        likelihood[dimensionIndex] = returner[3];
        betaL[dimensionIndex] = returner[4];
        betaU[dimensionIndex] = returner[5];
        t1 = 1.0D / sigma[dimensionIndex];
        costPrecalculation1[dimensionIndex] = (StrictMath.sqrt(StrictMath.exp(returner[6])) / returner[8]) * StrictMath.pow(returner[7], -1.5D) * t1;
        costPrecalculation2[dimensionIndex] = -returner[9];
        //System.out.println(p);
        return returner;
    }

    public double[] optimizeHelp(double lb, double ub, double betaL, double betaU, double betaF)
    {
        betaDimI = 0.5D * (betaL + betaU);
        p = 2D / (1.0D + betaDimI);
        logp = StrictMath.log(p);
        pp = p * p;
        OneThroughp = 1.0D / p;
        pMin1 = p - 1.0D;
        mu_limit = 0.001D * (ub - lb);
        oh_mu = 0.5D * (ub + lb);
        lb2optimize = lb;
        double arr$[];
        int len$;
        for(ub2optimize = ub; ub2optimize - lb2optimize > mu_limit;)
        {
            mu_sum = 0.0D;
            arr$ = sample;
            len$ = arr$.length;
            for(int i$ = 0; i$ < len$; i$++)
            {
                double sampleI = arr$[i$];
                if(sampleI > oh_mu)
                    mu_sum += StrictMath.pow(sampleI - oh_mu, pMin1);
                else
                    mu_sum -= StrictMath.pow(oh_mu - sampleI, pMin1);
            }

            if(mu_sum > 0.0D)
                lb2optimize = oh_mu;
            else
                ub2optimize = oh_mu;
            oh_mu = 0.5D * (ub2optimize + lb2optimize);
        }

        sum = 0.0D;
        arr$ = sample;
        len$ = arr$.length;
        for(int i$ = 0; i$ < len$; i$++)
        {
            double sampleI = arr$[i$];
            sum += StrictMath.pow(StrictMath.abs(sampleI - oh_mu), p);
        }

        for(oh_sigma = StrictMath.max(minSigma, StrictMath.pow(sum / (double)n, OneThroughp)); betaU - betaL > betaF; oh_sigma = StrictMath.max(minSigma, StrictMath.pow(sum / (double)n, OneThroughp)))
        {
            sum = 0.0D;
            logsum = 0.0D;
            arr$ = sample;
            len$ = arr$.length;
            for(int i$ = 0; i$ < len$; i$++)
            {
                double sampleI = arr$[i$];
                h = StrictMath.abs(sampleI - oh_mu);
                h2 = StrictMath.pow(h, p);
                sum += h2;
                logsum += h2 * StrictMath.log(h);
            }

            sigma_p = StrictMath.pow(oh_sigma, p);
            pThroughSigma = p / sigma_p;
            dldp = (((((double)n * logp - (double)n) + (double)n * Num.digamma(OneThroughp) + (double)n * p) - pThroughSigma * logsum) + sum / sigma_p + sum * StrictMath.log(oh_sigma) * pThroughSigma) / pp;
            if(dldp > 0.0D)
                betaU = betaDimI;
            else
                betaL = betaDimI;
            betaDimI = 0.5D * (betaL + betaU);
            p = 2D / (1.0D + betaDimI);
            logp = StrictMath.log(p);
            pp = p * p;
            OneThroughp = 1.0D / p;
            pMin1 = p - 1.0D;
            lb2optimize = lb;
            for(ub2optimize = ub; ub2optimize - lb2optimize > mu_limit;)
            {
                mu_sum = 0.0D;
                arr$ = sample;
                len$ = arr$.length;
                for(int i$ = 0; i$ < len$; i$++)
                {
                    double sampleI = arr$[i$];
                    if(sampleI > oh_mu)
                        mu_sum += StrictMath.pow(sampleI - oh_mu, pMin1);
                    else
                        mu_sum -= StrictMath.pow(oh_mu - sampleI, pMin1);
                }

                if(mu_sum > 0.0D)
                    lb2optimize = oh_mu;
                else
                    ub2optimize = oh_mu;
                oh_mu = 0.5D * (ub2optimize + lb2optimize);
            }

            sum = 0.0D;
            arr$ = sample;
            len$ = arr$.length;
            for(int i$ = 0; i$ < len$; i$++)
            {
                double sampleI = arr$[i$];
                sum += StrictMath.pow(StrictMath.abs(sampleI - oh_mu), p);
            }

        }

        t = 1.0D + OneThroughp;
        d = Num.lnGamma(t);
        oh_help = (double)(-n) * (StrictMath.log(2D * StrictMath.pow(p, OneThroughp) * oh_sigma) + d) - sum / p / sigma_p;
        tb1 = Num.lnGamma(1.5D + 1.5D * betaDimI);
        tb2 = StrictMath.exp(Num.lnGamma(0.5D + 0.5D * betaDimI));
        tb3 = 1.0D + betaDimI;
        c = StrictMath.pow(StrictMath.exp(tb1) / tb2, 1.0D / tb3);
        oh_sigma *= StrictMath.pow(c * p, OneThroughp);
        double r[] = {
            oh_mu, oh_sigma, betaDimI, oh_help, betaL, betaU, tb1, tb2, tb3, c
        };
        
        return r;
        
    }

    public static void main(String args[])
    {
    	long   start   =   System.currentTimeMillis();
        EPD epd = new EPD(2);
        ReadData rd = new ReadData();
        double[][] data = rd.readData("DS1_Norm_1000_2.txt",1000,2);
        double[] params;
        int len = data.length;
        int dim = data[0].length;
        double[] temp = new double[len];
        
        double src_cost = 0.0;
        for(int k=0;k<dim;k++){
	        for(int j = 0;j < len; j++)
	        	temp[j] = data[j][k];
		    epd.estimate(temp, k);        
	        for(int j = 0; j < len; j++)
	            src_cost += epd.cost(data[j][k], k);
        }
        src_cost = src_cost;
        System.out.println(src_cost);
        System.out.println("========================");
        int cur = 1;
        for(int i=0;i<len;i++){
	        for(int k=0;k<dim;k++){
	        	int num = 0;
		        for(int j=0;j<len;j++){
		        	if(j!=cur){
		        		temp[num] = data[j][k];
		        		num = num + 1;
		        	}
		        }
			    epd.estimate(temp, k);
	        }     
	
	        double tmp_cost = 0.0;
	        for(int j = 0; j < len; j++)
	        {
	        	if(j!=cur){
		            for(int k = 0; k < dim; k++)
		                tmp_cost += epd.cost(data[j][k], k);
	        	}
	        }
	        
	        tmp_cost = tmp_cost /len*dim;
	        cur = cur + 1;
	        System.out.println(src_cost-tmp_cost);
        }
    	long   end   =   System.currentTimeMillis(); 
      	System.out.println("All running time:"+Long.toString(end-start)+" ms.");        
    }

    int dimensions[];
    int dim;
    boolean verbose;
    boolean vverb;
    boolean correctSigma;
    public static double minSigma = 0.001D;
    private double t1;
    private double t2;
    private double t6;
    private double log2;
    public double mu[];
    public double sigma[];
    public double beta[];
    public double likelihood[];
    public double costPrecalculation1[];
    public double costPrecalculation2[];
    int i1;
    double tmp_sigma;
    double tmp_beta;
    double tmp_mu;
    double tb1;
    double tb2;
    double tb3;
    public double codingCostMin;
    public double codingCost0;
    double mu_limit;
    double mu_mean;
    double mu_sum;
    double sum;
    double logsum;
    double h2;
    double pp;
    double sigma_p;
    double logp;
    double pThroughSigma;
    double betaDimI;
    double oh_mu;
    double oh_sigma;
    double oh_help;
    double oh_h;
    double h;
    double r[];
    double r1[];
    double r2[];
    double r3[];
    double returner[];
    double lb[];
    double ub[];
    double betaL[];
    double betaU[];
    int n;
    double sample[];
    boolean firstGuess;
    double p;
    double pMin1;
    double OneThroughp;
    double betaF;
    double lb2optimize;
    double ub2optimize;
    double dldp;
    double c;
    double t;
    double d;

}